#include <avr/io.h>

#include "sharp2d120x/sharp2d120x.h"


void sharp_ir_init() {
	// Set as input
	IR_DDR &= ~(1 << 0x0F);

	// Uses ADC
	init_adc();
	

}


/**
* Uses a 3 degree polynom to convert from volts to cm. See matlab file polyfun.m
*/
uint8_t read_sharp_ir(uint8_t channel) {
	uint16_t adcval;
	uint16_t d;
	double v;

	// Read ADC value
	adcval = read_adc(channel);//adc_filtered_read(channel, 10);

	// That is in volt:
	// 0.72V is the offset given by virtual earth (grounded through AVR pin).
    v = ((double)adcval) * ((double)5) / ((double)256);	
	//printf("Test %f \n", v);

	// Convert to distance:
	return (uint8_t)(-12.3*v*v*v + 70.5*v*v - 126.3*v + 76);
}


