/*
** ** ** ** ** **  Begin header  ** ** ** ** ** ** **
**
** Project : Byggelab i faget TTK4155 Industrielle Datasystemers Konstruksjon 2005
** Filename : rs232serial.c
** Version : 1
** Date : 23.11.2005
**
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** **
**
** Copyright (c) 2005, Kristian M. Knausg�d, Gunnar Kjemphol
** All rights reserved.
**
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** **

VERSION LOG:

-----------
Version: 2
Date: 03.09.2006
Authors: Kristian M. Knausg�d
Coauthors: <none>
Description : Updated name convention.
Target platform: ATTiny2313

-----------
Version: 1
Date: 23.11.2005
Authors: Kristian M. Knausg�d, Gunnar Kjemphol
Coauthors: <none>
Description : Original version.
Target platform: ATMega128

FILE FUNCTIONALITY DESCRIPTION:
-----------

RS232 driver for ATTiny2313 using uart

** ** ** ** ** ** ** End header ** ** ** ** ** ** ** **
*/


#include <avr/io.h>
#include <avr/signal.h>

#include "usart1_driver.h"

char buffer[100];
int buffer_pos;


void usart1_init(unsigned int baud){
	// Initialize buffer:
	buffer_pos = 0;
	
	// Set baud rate
	UBRR1H = (unsigned char)(baud>>8);
	UBRR1L = (unsigned char)baud;
	
	// Enable interupt vectors
	//UCSR0A = 

	// Receiver and transmitter and RX Complete 
	UCSR1B = (1<<RXEN1)|(1<<TXEN1);
	
	// Set frame format: 8data 1stop
	UCSR1C = (0<<USBS1)|(3<<UCSZ01);
}

int usart1_putc(char c) { //, FILE *stream) {  static
//	if (c == '\n')
 //       uart_putchar('\r', stream);	// Adds terminal carrige return character
	while(!(UCSR1A & (1<<UDRE1))){
		// Wait for empty transmit buffer
	}
	UDR1 = c;
    return 0;
}

unsigned char usart1_getc(void){
	// Wait for incoming data
	while(!(UCSR1A & (1<<RXC1))){
		
	}
	return UDR1;
}

// Interupt vektor 19 RX interupt
/*
SIGNAL(SIG_USART1_RECV){
	printf("signal active...\n\r");
	char n;
	int i;
	n = USART1_getc();
	buffer[buffer_pos] = n;
	if(n == 13){ // 13 is return

		for(i = 0; i < buffer_pos; i++){
			printf("%c",buffer[i]);
		}
		printf("\n\r");
		buffer_pos = 0;	
	}
	else
		buffer_pos++;
}
*/

