#include <avr/io.h>
#include "SPI_driver.h"
#include "ls7366_quad_driver.h"
#include "at90can128_driver.h"


#define DUMMY_BYTE 0x55

#define WRITE_MDR0 0x88
#define WRITE_MDR1 0x90
#define WRITE_DTR 0x98

#define READ_MDR0 0x48
#define READ_MDR1 0x50
#define READ_CNTR 0x60
#define READ_OTR 0x68
#define READ_STR 0x30

#define CLEAR_MDR0 0x08
#define CLEAR_MDR1 0x10
#define CLEAR_CNTR 0x20
#define CLEAR_STR 0x30

#define LOAD_CNTR 0xE0
#define LOAD_OTR 0xE8


int init_ls7366_quad_driver(){
	char cData[2];
	SPI_MasterInit();
	
	// MDR0 init
	cData[0] = WRITE_MDR0;
//	cData[1] = 0x01;  	// 0b00000001
	// x4 quadrature count mode
	cData[1] = 0x03;  	// 0b00000011
	SPI_MasterTransmit(&cData, 2, SPI_PORTB_CS_A);

	// MDR1 init
	cData[0] = WRITE_MDR1;
	cData[1] = 0x00;  	// 0b00000000
	SPI_MasterTransmit(&cData, 2, SPI_PORTB_CS_A);
	
	// Clear STR
	cData[0] = CLEAR_CNTR;
	SPI_MasterTransmit(&cData, 1, SPI_PORTB_CS_A);
	
	return 0;
	
}


int read_ls7366_CNTR(void *ptr){
	can_message can_message_1, *can_message_ptr;
	can_message_ptr = ptr;
	char cData[1];
	can_message_ptr->id = 0x90;
	can_message_ptr->length = 4;
	cData[0] = READ_CNTR;
	// chip select on
	PORTB &= ~(1 << SPI_PORTB_CS_A);
	SPI_MasterTransmit_no_cs(&cData, 1);
	cData[0] = DUMMY_BYTE;
	can_message_ptr->bytes[3] = SPI_MasterTransmit_no_cs(&cData, 1);
	cData[0] = DUMMY_BYTE;
	can_message_ptr->bytes[2] = SPI_MasterTransmit_no_cs(&cData, 1);
	cData[0] = DUMMY_BYTE;
	can_message_ptr->bytes[1] = SPI_MasterTransmit_no_cs(&cData, 1);
	cData[0] = DUMMY_BYTE;
	can_message_ptr->bytes[0] = SPI_MasterTransmit_no_cs(&cData, 1);

	// chip select off
	PORTB |= (1 << SPI_PORTB_CS_A);
	
	// Clear STR
//	cData[0] = CLEAR_CNTR;
//	SPI_MasterTransmit(&cData, 1, SPI_PORTB_CS_A);
	
	
	return 0;

}
