/*
** ** ** ** ** **  Begin header  ** ** ** ** ** ** **
**
** Project : Byggelab i faget TTK4155 Industrielle Datasystemers Konstruksjon 2005
** Filename : rs232serial.c
** Version : 1
** Date : 23.11.2005
**
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** **
**
** Copyright (c) 2005, Kristian M. Knausgrd, Gunnar Kjemphol
** All rights reserved.
**
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** **

VERSION LOG:
-----------
Version: 1
Date: 23.11.2005
Authors: Kristian M. Knausgrd, Gunnar Kjemphol
Coauthors: <none>
Description : Original version.
Target platform: ATMega128

FILE FUNCTIONALITY DESCRIPTION:
-----------

RS232 driver for ATMEGA128 using uart

** ** ** ** ** ** ** End header ** ** ** ** ** ** ** **
*/


#include <avr/io.h>
#include <avr/interrupt.h>

#include "rs232serial.h"

char buffer[50];
int buffer_pos;


void USART_Init(unsigned int baud, unsigned int receive_buffer_size){
	// Initialize buffer:
	buffer_pos = 0;
	

	// Set baud rate
	UBRR0H = (unsigned char)(baud>>8);
	UBRR0L = (unsigned char)baud;
	
	// Enable interupt vectors
	// Receiver and transmitter and RX Complete 
	UCSR0B |= (1<<RXEN0)|(1<<TXEN0);
	
	// Set frame format: 8data 1stop
	UCSR0C |= (1<<UCSZ01)|(1<<UCSZ00);
	UCSR0C &= ~(1<<USBS0); 
	

}

void USART_Transmit(unsigned char data){
	// Wait for empty transmit buffer
	while(!(UCSR0A & (1<<UDRE0))){
		
	}
	UDR0 = data;
	
}

unsigned char USART_Receive(void){
	// Wait for incomming data
	while(!(UCSR0A & (1<<RXC0))){
		
	}
	return UDR0;
}

// Interupt vektor 19 RX interupt
SIGNAL(SIG_USART0_RECV){

	char n;
	int i;
	n = USART_Receive();
	buffer[buffer_pos] = n;
	if(n == 13){ // 13 is return

		for(i = 0; i < buffer_pos; i++){
			printf("%c",buffer[i]);
		}
		printf("\n\r");
		buffer_pos = 0;	
	}
	else
		buffer_pos++;
	
	
}


