/*
** ** ** ** ** **  Begin header  ** ** ** ** ** ** **
**
** Project : Byggelab i faget TTK4155 Industrielle Datasystemers Konstruksjon 2005
** Filename : SPI_driver.c
** Version : 1
** Date : 23.11.2005
**
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** **
**
** Copyright (c) 2005, Kristian M. Knausgrd, Gunnar Kjemphol
** All rights reserved.
**
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** **

VERSION LOG:
-----------
Version: 1
Date: 23.11.2005
Authors: Kristian M. Knausgrd, Gunnar Kjemphol
Coauthors: <none>
Description : Original version.
Target platform: ATMega128

FILE FUNCTIONALITY DESCRIPTION:
-----------


** ** ** ** ** ** ** End header ** ** ** ** ** ** ** **
*/

#include <avr/io.h>

#include "SPI_driver.h"


void SPI_MasterInit(void){
	// Set MOSI and SCK output, all others input 
	//DDR_SPI =  (1<<DD_MOSI)|(1<< DD_SCK);
	DDRB |=  (1<<PB1)|(1<< PB2);
	// Add also chip select (CS) signals as outputs
	DDRB |= (1<<SPI_PORTB_CS_A);
	
	
	// Enable SPI, Master, set clock rate fck/4
	SPCR = (1<<SPE)|(1<<MSTR); //|(0<<CPOL)|(0<<CPHA)|(1<<SPR1)|(1<<SPR0);


}

char SPI_MasterTransmit(char *cData, int cdata_length, char cs){
	char data;
	// chip select on
	PORTB &= ~(1<<cs);
	
	int i;
	for(i=0;i<cdata_length;i++) {
		// Start transmission
		SPDR =cData[i];	
		// wait for transmission complete
		while(!(SPSR & (1<<SPIF)));
		data = SPDR;

	}

	
	// chip select off
	PORTB |= (1<<cs);
	
	return data;
}

char SPI_MasterTransmit_no_cs(char *cData, int cdata_length){
	char data;
	
	int i;
	for(i=0;i<cdata_length;i++) {
		// Start transmission
		SPDR =cData[i];	
		// wait for transmission complete
		while(!(SPSR & (1<<SPIF)));
		data = SPDR;

	}

	return data;
}


