#include <avr/io.h>
#include <avr/interrupt.h>

#define EVER ;;

#define CDMA_STATE_OFFLINE 		0
#define CDMA_STATE_TRANSMITTING 1

#define BURST 		350									/* Length of burst 8, 20 35*/
#define PAUSE		350									/* Length of pause */


ISR(TIM0_COMPB_vect);
char burstcount = 0;


// Current CDMA transmitter state
int transmitter_state;

// The chipcode of this transmitter
uint8_t chipcode[] = { 0,0,0,0,0,0,0,0, 1,1,1,1,1,1,1,1, 0,0,0,0,0,0,0,0, 1,1,1,1,1,1,1 };	// Most significant bit is don't care..
uint8_t chipcode_length = 31;
uint8_t chippointer = 0;
uint8_t chip = 0; // The current chip value


/**
* Set transmitter state and set up timer
*/
void init_cdma() {
	transmitter_state = CDMA_STATE_OFFLINE;

	// Timer0
	DDRB = (1<<PB1)	;									// OC1b output
	TIMSK0 |= (1<<OCIE0B);								// Interrupt on output compare B
	OCR0A = 21; 										// TOP-value to select correct pwm-frequency
	OCR0B = 10;	 										// 50% duty-cycle
	TCCR0A = (1<<COM0B1) | (1<<WGM01) | (1<<WGM00);		// MODE7: Fast pwm with TOP = OCR0A and prescaler = 1
	TCCR0B = (1<<WGM02)  | (1<<CS00);
}


/**
* Increment chip-pointer to transfer next chip in the chipcode (cyclic)
*/
void cdma_update() {
	chip = (chipcode >> chippointer++) & 0x01;
	if(chippointer>chipcode_length) chippointer = 0;
}


/**
*
*/
int main(void) {
	// Init
	init_cdma();

	// Enable global interrupts
	sei();

	// Hang here
	for(EVER);
}


int high = 0;

/**
* Interrupt service routine
*/
ISR(TIM0_COMPB_vect){
	burstcount++;
	if(burstcount>10){
		burstcount = 0;
		if(high){
			DDRB  |=  (1<<PB1);
			high=0;
		}
		else{
			DDRB &= ~(1<<PB1);
			high=1
		}
		
		
	}
	/*if((burstcount == BURST) && chip) {
		TCCR0A &= ~(1<<COM0B1);							// Disconnect OC0B
		DDRB  |=  (1<<PB1);
		PORTB &= ~(1<<PB1);
	} else if (burstcount == BURST + PAUSE) {
		TCCR0A |= (1<<COM0B1);							// Connect OC0B
		burstcount = 0;									// Reset burst-counter
		cdma_update();
	}*/
}

