#include <avr/io.h>
#include <avr/interrupt.h>


#define TOWER 2


ISR(TIM0_COMPB_vect);
char burstcount = 0;


/**
* Set up timer and PWM
*/
void init() {

	// Timer0
	DDRB = (1<<PB1)|(1<<PB2);									// OC1b output
	TIMSK0 |= (1<<OCIE0B);								// Interrupt on output compare B
	OCR0A = 21; 										// TOP-value to select correct pwm-frequency
	OCR0B = 10;	 										// 50% duty-cycle
	TCCR0A = (1<<COM0B1) | (1<<WGM01) | (1<<WGM00);		// MODE7: Fast pwm with TOP = OCR0A and prescaler = 1
	TCCR0B = (1<<WGM02)  | (1<<CS00);
	
	PORTB &= ~(1<<PB2); // Set status light
}



/**
*
*/
int main(void) {
	// Init
	init();

	// Enable global interrupts
	sei();


	while(1){
	
	}
}

int high = 0;

/**
* Interrupt service routine
*/
ISR(TIM0_COMPB_vect){
	burstcount++;
	if(burstcount>(TOWER*10)){
		burstcount = 0;
		if(high){
			DDRB  |=  (1<<PB1);
			high=0;
		}
		else{
			DDRB &= ~(1<<PB1);
			high=1;
		}
		
		
	}
}

