#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

#define EVER ;;

#define CDMA_STATE_OFFLINE 		0
#define CDMA_STATE_TRANSMITTING 1



ISR(TIMER1_COMPA_vect);
char burstcount = 0;


// Current CDMA transmitter state
int transmitter_state;

// The chipcode of this transmitter Funket med denne: 0,0,0,0,0,0,0,0, 1,1,1,1,1,1,1,1, 0,0,0,0,0,0,0,0,  0,0,0,0,0,0,0 }; //
uint8_t chipcode[] = { 0,1,0,1,0,1,0,0,0,1,0,1,1,1,1,0,1,1,1,0,0,0,1,0,1,1,0,0,1,0,1 }; //0,0,0,0,0,0,0,0, 1,1,1,1,1,1,1,1, 0,0,0,0,0,0,0,0, 1,1,1,1,1,1,1 };	// Most significant bit is don't care..
#define CHIPCODE_LENGTH 31
//uint8_t i;
//uint8_t chip = 0; // The current chip value


/**
* Set transmitter state and set up timer
*/
void init_cdma() {
	//transmitter_state = CDMA_STATE_OFFLINE;

	// Timer0
	//DDRB = (1<<PB1)	;									// OC1b output
	//TIMSK0 |= (1<<OCIE0B);								// Interrupt on output compare B
	//OCR0A = 21; 										// TOP-value to select correct pwm-frequency
	//OCR0B = 10;	 										// 50% duty-cycle
	//TCCR0A = (1<<COM0B1) | (1<<WGM01) | (1<<WGM00);		// MODE7: Fast pwm with TOP = OCR0A and prescaler = 1
	//TCCR0B = (1<<WGM02)  | (1<<CS00);

	//DDRD |= (1 << PD0);	// CDMA CLK out	
	//DDRD |= (1 << PD1);	// CDMA tx
	
	DDRB = 0b00010101;
	
	PORTB &= ~(1 << PD0);	// Shutdown off
	PORTB &= ~(1 << PD4);	// Mode 1
	/*
	DDRD = 0b00010101;
	
	PORTD &= ~(0 << PD0);	// Shutdown off
	PORTD &= ~(0 << PD4);	// Mode 1

	DDRC = 0x01;
	*/
	TCCR1A = 0;	// No external pin connection.
	TCCR1B  = (1 << WGM12)| (0 << CS12)| (0 << CS11) | (1 << CS10); /* CTC, prescale = 128 */
	//TIFR1  |= _BV(OCIE1A)|_BV(TOIE1);
	TIMSK1 |= _BV(TOIE1)|_BV(OCIE1A);         /* enable output compare interrupt */
	
	TCNT1  = 0;
	OCR1A   = 640;// 800; //640
}


/**
*
*/
int main(void) {
	// Init
	init_cdma();	

	// Enable global interrupts
	sei();
	

	// Hang here
	for(EVER) {
	}
}


/**
* Interrupt service routine
*/
ISR(TIMER1_COMPA_vect){
	static uint8_t i = CHIPCODE_LENGTH;
	i--;
	
	//PORTD |= (1 << PD1);


	// Put on output pin
	switch(chipcode[i]) {
		case 0:
			PORTB &= ~(1 << PB2);
		break;
		default:
			PORTB |= (1 << PB2);
		break;
	}
	
	if(i<=0) i = CHIPCODE_LENGTH;

	// Klokkesignal (trigger på oppgadgående flanke)
	//_delay_us(100);
	//PORTD |= (1 << PD0);
	//_delay_us(100);
	//PORTD &= ~(1 << PD0);
	
}

