/*
** ** ** ** ** **  Begin header  ** ** ** ** ** ** **
**
** Project : Byggelab i faget TTK4155 Industrielle Datasystemers Konstruksjon 2005
** Filename : rs232serial.c
** Version : 1
** Date : 23.11.2005
**
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** **
**
** Copyright (c) 2005, Kristian M. Knausg�d, Gunnar Kjemphol
** All rights reserved.
**
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** **

VERSION LOG:

-----------
Version: 2
Date: 03.09.2006
Authors: Kristian M. Knausg�d
Coauthors: <none>
Description : Ported to Updated name convention.
Target platform: ATTiny2313

-----------
Version: 1
Date: 23.11.2005
Authors: Kristian M. Knausg�d, Gunnar Kjemphol
Coauthors: <none>
Description : Original version.
Target platform: ATMega128

FILE FUNCTIONALITY DESCRIPTION:
-----------

RS232 driver for ATTiny2313 using uart

** ** ** ** ** ** ** End header ** ** ** ** ** ** ** **
*/


#include <avr/io.h>
#include <avr/signal.h>

#include "usart0_driver.h"




void usart0_init(unsigned int baud){
	// Initialize buffer:
	//buffer_pos = 0;
	UCSRC = 0x00;
	// Set baud rate
	UBRRH = (unsigned char)(baud>>8);
	UBRRL = (unsigned char)baud;
	
	// Enable interupt vectors
	//UCSR0A |= (1 << RXC0); 

	UCSRA |= (1<<U2X);
	
	// Receiver and transmitter and RX Complete 
	UCSRB = (1<<RXEN) |(1<<TXEN);
	
	// Set frame format: 8data 1stop
	UCSRC = (1<<URSEL)|(0<<USBS)|(1<<UCSZ0)|(1<<UCSZ1);
}

void usart0_putc(unsigned char data){
	// Wait for emty transmit buffer
	while(!(UCSRA & (1<<UDRE))){
		
	}
	UDR = data;
}

/*unsigned char usart0_getc(void){
	// Wait for incoming data
	while(!(UCSRA & (1<<RXC))){
		
	}
	return UDR;
}*/



