#include <avr/io.h>
#include <util/delay.h>
#include <string.h>
#include <stdio.h>
#include <avr/sleep.h>
#include <avr/interrupt.h>

#include "usart0_driver.h"
#include "usart1_driver.h"

#define EVER ;;
#define TRUE 1
#define FALSE 0
#define TARGET_FREQ 16000000UL // This is defined in the Makefile as well...
#define ATMEGA8_BAUD(baud_rate) ((TARGET_FREQ / (8UL * (baud_rate))) - 1)

#define DELAY_STARTUP_FOR_S 1
#define BEACON_DETECTED 1

// IRDA ENC/DEC Card
#define RX 0
#define TX 1
#define ED_MODE PC0
#define ED_EN PC1
#define TR_MODE PC2
#define ED_RST PD3	// Denne er ikke i bruk da den var bortglemt fra kretskortet
#define TR_SD PC3

#define SENSOR1 0
#define T1 1
#define T2 2
#define T3 4
#define T4 8

#define IR_TX_PAUSE		35
// Expected duty cycles 8, 20 35
#define T1_PULSELENGTH	7
#define T2_PULSELENGTH	14
#define T3_PULSELENGTH	21
#define T4_PULSELENGTH	28
#define SLACK 2


/**
* Busywait s seconds
*/
void _delay_s(uint8_t s) {
	uint8_t i;
	s*=10;
	for(i=0;i<s;i++) {
		_delay_ms(100);
	}
}


/**
* Initialize
*/
int8_t init(void) {

	cli();

	// Set up USART for IRDA
	usart0_init(ATMEGA8_BAUD(57600UL));//8);
	fdevopen(usart0_putc, NULL);



	// Set control pins as output
	DDRC |= (1 << ED_MODE) | (1 << ED_EN) | (1 << TR_MODE) |  (1 << TR_SD);
	DDRD |= (1 << ED_RST);

	// Set data mode + reset on + mode + tranceiver shutdown off
	PORTC = (0 << ED_MODE) | (1 << ED_RST) | (1 << ED_EN) | (0 << TR_MODE);
	PORTD |= (1 << ED_RST);
	PORTC &= ~(1 << TR_SD);


	//_delay_ms(1);
	//PORTE |= (1 << RST);

	// Enable interrupts
	//sei();


	// Timer
	/*TCCR1A = 0;	// No external pin connection.
	TCCR1B  = (1 << WGM12)| (0 << CS12)| (0 << CS11) | (1 << CS10); // CTC, prescale = 128
	//TIFR1  |= _BV(OCIE1A)|_BV(TOIE1);
	TIMSK |= _BV(TOIE1)|_BV(OCIE1A);         // enable output compare interrupt

	TCNT1  = 0;
	OCR1A   = 255;// 800; //640*/

	
}

int timer=0;

/**
*
*/
int main(void) {
	// Init
	init();

	// Enable global interrupts
	sei();

	DDRD |= (1 << PIN6) | (1 << PIN7);


	// Hang here
	while(1){
		if((PINB&0x04)){
			printf("%d",0);
		}
		else{
			printf("%d",1);
		}
		//printf("PINB: %x \n\r", (PINB&0x04));
		//printf("hei");
		_delay_ms(10);
	}
}


/**
* ISR for timer 1
*/
//ISR(TIMER1_COMPA_vect){
	//PORTD |= (1<<PIN6);
	//timer++;
	/*static uint8_t i1=0,i2=0,i3=0,i4=0;
	uint8_t detected;
	uint8_t received = ~PINB;*/
/*
	detected = (T4 << 4);
	if(received & (1<<SENSOR1)) {
		i1++;
	} else if(i1>T1_LOW && i1<T1_HIGH) {
		detected = T1;
	} else if(i1>T2_LOW && i1<T2_HIGH) {
		detected = T2;
	} else if(i1>T3_LOW && i1<T3_HIGH) {
		detected = T3;
	} else if(i1>T4_LOW && i1<T4_HIGH) {
		detected = T4;
	} else {
		i1=0;
	}
	if(detected) { usart0_putc(detected); }
	*/
//}