#include <avr\io.h>

#include <avr\interrupt.h>

#include <avr\iom8.h>
#include <avr\delay.h>

#define ICP PINB0

//define ovrflow counter

uint16_t ov_counter;

//define times for start and end of signal

uint16_t rising, falling;

//define overall counts

uint32_t counts;

//overflow counter interrupts service routine

ISR(TIMER1_OVF_vect){

  ov_counter++;

}

//Timer1 capture interrupt service subroutine

ISR(TIMER1_CAPT_vect){

/*This subroutine checks was it start of pulse (rising edge)

or was it end (fallingedge)and performs required operations*/

if (ICP) //if high level

            {

            //save start time

            rising=ICR1;

            //set to trigger on falling edge

            TCCR1B=TCCR1B&0xBF;

            //reset overflow counter

            ov_counter=0;

   }

else

            {

            //save falling time

            falling=ICR1;

            //rising edge triggers next

            TCCR1B=TCCR1B|0x40;

            counts=(uint32_t)falling-(uint32_t)rising+(uint32_t)ov_counter;

            /*you can convert coutns to seconds and send to LCD*/

            }

}

int main(void) {

usart0_init(16);

//enable overflow and input capture interrupts

TIMSK=0x24;

/*Noise canceller, without prescaler, rising edge*/

TCCR1B=0xC1;

sei();

    for (;;) {

/* loop forever timer does the job*/
		usart0_putc(counts);
		usart0_putc('a');
		 _delay_ms(255);
 

    }

}