/*
* Kristian M. Knausgård 2007
*/

#include <avr/io.h>
#include <util/delay.h>
#include <string.h>
#include <stdio.h>
#include <avr/sleep.h>
#include <avr/interrupt.h>

#include "usart0_driver.h"
#include "usart1_driver.h"

#define EVER ;;
#define TRUE 1
#define FALSE 0
#define TARGET_FREQ 16000000UL//14745600UL // This is defined in the Makefile as well...
#define ATMEGA128_BAUD(baud_rate) ((TARGET_FREQ / (16UL * (baud_rate))) - 1)

#define DELAY_STARTUP_FOR_S 1

// IRDA ENC/DEC Card
#define RX 0
#define TX 1
#define MODE2120 2
#define EN 3
#define MODETR 4
#define RST 5
#define SD 7


/**
* Busywait s seconds
*/
void _delay_s(uint8_t s) {
	uint8_t i;
	s*=10;
	for(i=0;i<s;i++) {
		_delay_ms(100);
	}
}


/**
* Initialize
*/
int8_t init(void) {

	cli();

	// Delayed startup
	#ifdef DELAY_STARTUP_FOR_S
	//    _delay_s(DELAY_STARTUP_FOR_S);
	#endif

	// Set up USART0 for IRDA
	usart0_init(ATMEGA128_BAUD(57600UL));//ATMEGA128_BAUD(19200UL));//8);
	usart1_init(ATMEGA128_BAUD(57600UL));


	// Set up USART0 for PC RS232
	//usart1_init(8);


	// Bind stdout to use uart1_putc on USB (printf is active after this very point)
	fdevopen(usart1_putc, NULL);
	printf("\n\nStarter IRDA testprogram...\n\r");

printf("%d",ATMEGA128_BAUD(20800UL));

	// Set control pins as output
	DDRE |= (1 << MODE2120) | (1 << EN) | (1 << MODETR) | (1 << RST) | (1 << SD);

	// Set data mode + reset on + mode + tranceiver shutdown off
	PORTE = (0 << MODE2120) | (1 << RST)| (1 << EN) | (0 << MODETR) | (0 << SD);

	//_delay_ms(1);
	//PORTE |= (1 << RST);

	// Enable interrupts
	//sei();

	// Return retval
	return 0;
}


/**
* Main method
*/
int main(void) {
	// Bistate variable
	uint8_t running = TRUE;
	// Postfix for files in case of incremental naming scheme

	// Run initialization
	init();



	// Activate progress LED
	//char led_red = 0;
	//char led_green = 0;

	/*DDRB |= (1 << PB6);
	DDRB |= (1 << PB7);

	#define LED_RED PB7
	#define LED_GREEN PB6

	PORTB &= ~(1 << LED_GREEN);
	PORTB |= (1 << LED_RED);

*/
	char irdata;
	printf("while");
	while(1){
		//irdata = usart0_getc();
		//printf("%c - a\n\r", irdata);
		usart0_putc('r');
		_delay_ms(255);_delay_ms(255);_delay_ms(255);_delay_ms(255);_delay_ms(255);_delay_ms(255);_delay_ms(255);_delay_ms(255);_delay_ms(255);_delay_ms(255);_delay_ms(255);_delay_ms(255);_delay_ms(255);_delay_ms(255);_delay_ms(255);_delay_ms(255);_delay_ms(255);_delay_ms(255);_delay_ms(255);_delay_ms(255);_delay_ms(255);

	}
	// Outer main-loop
	char i = 0;
	while(running) {
		i++;
		    // Enable interrupts globally
		    //sei();

		usart0_putc('b');
		_delay_ms(100);
		//printf("M: %d\n\r", usart0_getc());
	}

	// Hang here for predictable behaviour
	for(EVER) {;}

	return 0;
}

