#include <util/delay.h>
#include <avr/io.h>
#include "adc_converter_can128.h"


int init_adc( void ){
	// External ref voltage
	ADMUX |= (1 << REFS0);
	
	// 8-bit resolution
	// Read only ADCH 
	ADMUX |= (1<<ADLAR);
	
	// ADC Prescaler 4
	ADCSRA |= (1 << ADPS1);
	
	// Enable ADC
	ADCSRA |= (1 << ADEN);

	return 0;
}


char read_adc( char adc_number ){
	// Select ADC number
	_delay_ms(255);
	ADMUX &= 0xE0;
	ADMUX |= adc_number;
		
	// wait 125us if changing adc_number
	_delay_us(125);
	
	// Start a single conversion
	ADCSRA |= (1 << ADSC);
	
	// Wait for conversion to complete
	while(ADCSRA & (1 << ADSC));

	return ADCH;
	


}
