#include <util/delay.h>
#include <avr/io.h>
#include <stdio.h>
#include <avr/interrupt.h>
#include "adc_converter_can128.h"
#include "at90can128_driver.h"
#include "uart.h"
#include "interrupts.h"

#define set_bit( reg, bit ) (reg |= (1 << bit))
#define clear_bit( reg, bit ) (reg &= ~(1 << bit))

#define MIN_ADC_VALUE	185	// The same as 185/255 * 16.8V = 12.2V

int main(void){
	int adc_0,adc_1;
	double volt_0, volt_1;
	//USART_Init(51);
	init_ext_interrupts(0);
	init_ext_interrupts(1);
	init_ext_interrupts(2);
	init_ext_interrupts(3);
	init_adc();
	init_can();
	DDRB=0xFF;
	//set_bit(PORTB,PB4);
	//DDRD=0xFF;
	//PORTD=0x55;
	//clear_bit(PORTB,PB0);
	//clear_bit(PORTB,PB2);
	//set_bit(PORTB,PB0);
	//set_bit(PORTB,PB1);
	//set_bit(PORTB,PB2);
	//set_bit(PORTB,PB3);
	//printf("Done initializing card!\n\r");
	sei();
    adc_0 = 0;
    adc_1 = 0;
    volt_0 = 0;
    volt_1 = 0;
	while(1){
		_delay_ms(255);
		_delay_ms(255);
		//send_can_team_color_blue_message();
		adc_0 = read_adc(0);
		volt_0 = (double)(adc_0)*(16.8/255);
		if(adc_0>=MIN_ADC_VALUE){
			clear_bit(PORTB,PB0);
			set_bit(PORTB,PB1);
		}
		else if(adc_0<MIN_ADC_VALUE && adc_0>10){
			set_bit(PORTB,PB0);
			clear_bit(PORTB,PB1);
            send_low_battery_message();
		}
		else{
			set_bit(PORTB,PB0);
			set_bit(PORTB,PB1);
		}
		_delay_ms(100);
		adc_1 = read_adc(1);
		volt_1 = (double)(adc_1)*(16.8/255);
		if(adc_1>=MIN_ADC_VALUE){
			clear_bit(PORTB,PB2);
			set_bit(PORTB,PB3);
		}
		else if(adc_1<MIN_ADC_VALUE && adc_1>10){
			set_bit(PORTB,PB2);
			clear_bit(PORTB,PB3);
            send_low_battery_message();
		}
		else{
			set_bit(PORTB,PB2);
			set_bit(PORTB,PB3);
		}
		//printf("*--------------------------*\n\r");
		//printf("adc_0: %d, adc_1: %d\n\r",adc_0,adc_1);
		//printf("volt_0: %f, volt_1: %f\n\r",volt_0,volt_1);
		//printf("%X\n\r",CANGSTA);
		//printf("a\n\r");
	}
	return 0;
}
