
#include "uart.h"


ISR(USART0_RX_vect){
	unsigned char buf;
	buf = USART_Receive();
	USART_Transmit(buf);
}

int USART_Send(char data, char *stream){
	USART_Transmit(data);
	return 0;
}


void USART_Init(unsigned int baud){					
	
	
	set_bit(DDRE,PINE1);
	clear_bit(DDRE,PINE0);
	
	/* Set baud rate */
	UBRR0H = (unsigned char)(baud>>8);
	UBRR0L = (unsigned char)baud;

	/* Enable receiver and transmitter */
	//UCSR0B = (1<<RXEN0)|(1<<TXEN0)|(1<<RXCIE0);
	
	//andre options
	//UCSR0C = (1<<URSEL0)|(1<<USBS0)|(3<<UCSZ00);
	
	//setter 8 data bits
	//UCSR0C = (1<<UCSZ01)|(1<<UCSZ00);

	/* Set frame format: 8data, no parity & 2 stop bits */
	UCSR0C = (0<<UMSEL0) | (0<<UPM0) | (1<<USBS0) | (3<<UCSZ0);
	/* Enable receiver and transmitter */
	UCSR0B = (1<<RXEN0) | (1<<TXEN0);


	fdevopen(USART_Send,0,0);
}


void USART_Transmit( unsigned char data )
{
	/* Wait for empty transmit buffer */
	while (!( UCSR0A & (1<<UDRE0)));
	
	/* Put data into buffer, sends the data */
	UDR0 = data;
}



unsigned char USART_Receive( void )
{
	/* Wait for data to be received */
	while (!(UCSR0A & (1<<RXC0)));
	
	/* Get and return received data from buffer */
	return UDR0;
}



