#include <iostream>
#include <cstdlib>
#include "vision.h"
#include "objrec.h"
#include "highgui.h"
#include "communication.h"
#include <signal.h>

#ifdef MESSAGESYSTEM
#include "MessageHandler.h"
#include "posix_message_queue.h"
#include "posix_message_config.h"
#endif


#define BALL 1
#define ROBOT 2
#define PICTURES_PER_MESSAGE 1

using namespace std;

int running=1;
int teamColor = 0;

#ifdef MESSAGESYSTEM

MessageHandler plansysMessageHandler(CVSYS_ID, PMQ_CVSYS, PMQ_PLANSYS, true);

void recieveCvObservaton(pmq_message *pm){
	cv_observation my_cv_observation;
	cv_observation return_cv_observation;
	memcpy((void *)(&my_cv_observation),( void * )pm->data, sizeof(cv_observation));
	cout << "mottatt melding type: " << my_cv_observation.type << endl;
	teamColor = my_cv_observation.teamColor;
	int counter = 0;
	while(counter<PICTURES_PER_MESSAGE){
		capture();
		switch(my_cv_observation.type){
			case BALL:
				printf("Ball\r\n");
				if(!findBall(&return_cv_observation,my_cv_observation.teamColor)){
					counter++;
				}
				else{
					counter = PICTURES_PER_MESSAGE;
				}

				break;
			default:
				printf("tydeligvis noe annet\r\n");
				return_cv_observation.type=NOTHING;
				return_cv_observation.x=0;
				return_cv_observation.y=0;
				counter = PICTURES_PER_MESSAGE;
				break;
		}
	}
	if(return_cv_observation.x==0||return_cv_observation.x>2000)return_cv_observation.type=NOTHING;   //DENNE SKULLE IKKE VÆRT NØDVENDIG!! :P
	return_cv_observation.ret=0;
	printf("Strukt sendt: x:%i,y: %i  type:%i\r\n",return_cv_observation.x,return_cv_observation.y,return_cv_observation.type);
	plansysMessageHandler.sendMessage( (char *)&return_cv_observation, (int)sizeof(cv_observation), MINOR_CV_OBSERVATION, PRIORITY_VERY_HIGH );
}

#endif


// first, here is the signal handler
void catch_int(int sig_num)
{
	// re-set the signal handler again to catch_int, for next time
	signal(SIGINT, catch_int);
	//taBilde();
	running=0;
	// and print the message
	fflush(stdout);
	printf("Stopping\r\n");
	running=0;
}
void catch_hup(int sig_num){
	// re-set the signal handler again to catch_int, for next time
	signal(SIGHUP, catch_hup);
}



int main(){

	int viewtype =BALL;
	int c;

	signal(SIGINT, catch_int);
	signal(SIGHUP, catch_hup);
	running = 1;

	cv_observation my_cv_observation;
#ifdef MESSAGESYSTEM
 plansysMessageHandler.addSubMessageHandler(recieveCvObservaton, MAJOR_STRUCT, MINOR_CV_OBSERVATION);
#endif

	running = initCamera();
while(running){

	usleep(50000);
	//findBall(&my_cv_observation,2);
	capture();
#ifdef USE_GUI
		c = cvWaitKey(10);   //cvWaitKey gir en liten minnelekkasje, muligens bare når den kjøres første gang, for den blir ikke større.
		if( (char)c == 'x' ) running=0;

		if( (char)c == 'b' ) viewtype=BALL;
		if( (char)c == 'r' ) viewtype=ROBOT;
		switch(viewtype){
			case BALL:
		 	findBall(&my_cv_observation,2);
				break;
			case ROBOT:
		 	findRobot(&my_cv_observation);
				break;
			default:
				break;
		}
#endif
		viewtype = 0;

}
	shutDownCamera();
}
