#include "vision.h"
#include "objrec.h"
#include "position.h"
#include "highgui.h"
#include <iostream>
#include <cstdlib>
#include <math.h>

#define INNMATERGRENSE	50
#define GRENSE1_TOPP		0
#define GRENSE1_BUNN		480
#define GRENSE1_HOYRE	640

#define GRENSE2_VENSTRE	130
#define GRENSE2_TOPP		0
#define GRENSE2_BUNN		480
#define GRENSE2_HOYRE	640

#define ROD_ROD         		220
#define ROD_GRONN			38
#define ROD_BLAA			5

#define BLAA_ROD        		20
#define BLAA_GRONN			40
#define BLAA_BLAA			160

#define HVIT_ROD        		160
#define HVIT_GRONN			200
#define HVIT_BLAA			210

#define DP		 		 2
#define MIN_DIST		25
#define PARAM_1		60
#define PARAM_2		63
#define MIN_R		   10
#define MAX_R		  100


#define WHITE		0
#define RED 		1
#define BLUE		2
#define INGEN_BALL      -1


IplImage *im =0;
IplImage *gray  = 0;
CvSeq* circles;
CvPoint bestball;
CvCapture *cam;
CvSize size;

const char *window = "Eurobot-cam";

int initCamera(){
IplImage *test_image =0;
	printf("starting camera \r\n");
	int i;

#ifdef TEST_IMAGE
	//im = cvLoadImage( "test.png");
	//size=cvGetSize(im);
#else
	for(i=0;i<6;i++){
		printf("Prøver kameranr %i\r\n",i);
		cam = cvCaptureFromCAM(i);
		if(cam!=NULL){
			printf("skjekker størrelse på kamera %i\r\n",i);
			test_image = cvQueryFrame(cam);
			size=cvGetSize(test_image);
			if(size.width==640) break;
		}
		if(i==5) return 0;
	}
	im = cvQueryFrame(cam);
	size = cvGetSize(im);
#endif

#ifdef USE_GUI
	cvNamedWindow(window, CV_WINDOW_AUTOSIZE);
#endif
	initCameraMatrix();
return 1;
}

void shutDownCamera(){
	cvReleaseCapture( &cam);
}

void taBilde(){
cvSaveImage("sistebilde.png",im);
}



int finnBestBall(CvPoint ballen){

   if(ballen.x > GRENSE1_TOPP &&ballen.x < GRENSE1_BUNN && ballen.y < GRENSE1_HOYRE && ballen.y > INNMATERGRENSE){
		if(ballen.y>bestball.y) return 0;
		else {
   		bestball.x = ballen.x;
   		bestball.y = ballen.y;
		return 1;
		}
   }
   else return 0;
}


bool capture(){
#ifdef TEST_IMAGE
	im = cvLoadImage( "testbilder/image4.png");
#else
 im = cvQueryFrame(cam);
#endif
}


bool findBall(cv_observation *ball,int color){

printf("teamColor: %d\n\r", color);
   int i;
	int r,g,b;
	int j, k;
	uchar currB,currG,currR;
	int braBall=0;
	int startX,endX,startY,endY;
	float radius,s;
	int hitCounterColored = 0;
	int hitCounterWhite = 0;

	int mean_R,mean_G,mean_B;


	bestball.x=480;
	bestball.y=640;
	im =cvCreateImage(size, IPL_DEPTH_8U, 3);

	CvMemStorage* storage = cvCreateMemStorage(0);
	capture();

	gray = cvCreateImage( cvGetSize(im), 8, 1 );
	cvCvtColor( im, gray, CV_BGR2GRAY );
	cvSmooth( gray, gray, CV_GAUSSIAN, 9, 9 ); // smooth it, otherwise a lot of false circles may be detected
	circles = cvHoughCircles(gray, storage, CV_HOUGH_GRADIENT, DP, MIN_DIST, PARAM_1, PARAM_2, MIN_R, MAX_R);


	switch(color)
	{
		case RED:
			r = ROD_ROD;
			g = ROD_GRONN;
			b = ROD_BLAA;
			break;
		case BLUE:
			r = BLAA_ROD;
			g = BLAA_GRONN;
			b = BLAA_BLAA;
			break;
		case WHITE:
			r = HVIT_ROD;
			g = HVIT_GRONN;
			b = HVIT_BLAA;
			break;
		default:
			break;
	}


	CvPoint funnet = cvPoint(0,0);
	CvPoint funnet_R = cvPoint(0,0);

	for( k = 0; k < circles->total; k++ )
	{
		float* p = (float*)cvGetSeqElem( circles, k );
	#ifdef USE_GUI
		cvCircle( im, cvPoint(cvRound(p[0]),cvRound(p[1])), cvRound(p[2]), CV_RGB(255,0,0), 3, 8, 0 );
	#endif
		radius = 0.85*p[2];
		s = 2*radius*cos(45*M_PI/180);
		//printf("Radius: %i\n\r",s);
		startX = (int) (cvRound(p[0]) - 0.5*s);
		startY = (int) (cvRound(p[1]) + 0.5*s);
		endX = (int) (cvRound(p[0]) + 0.5*s);
		endY = (int) (cvRound(p[1]) - 0.5*s);
	#ifdef PRINT
		printf("Ball nr: %i: \n\r",k);
		#endif
		mean_R =0;
		mean_G =0;
		mean_B =0;
		int pixels=0;
		for(i=startY;i>endY;i--){
			for(j=startX;j<endX;j++){
				currR = ((uchar *)(im->imageData + i*im->widthStep))[j*im->nChannels + 2];
				currG = ((uchar *)(im->imageData + i*im->widthStep))[j*im->nChannels + 1];
				currB = ((uchar *)(im->imageData + i*im->widthStep))[j*im->nChannels + 0];

				pixels++;
				mean_R+=currR;
				mean_G+=currG;
				mean_B+=currB;
				switch(color)
				{
					case RED:
						if((currB-ROD_BLAA)*(currB-ROD_BLAA)+(currG-ROD_GRONN)*(currG-ROD_GRONN)+ (currR-ROD_ROD)*(currR-ROD_ROD)<12000){
							hitCounterColored++;
						}
						else if((currB-HVIT_BLAA)*(currB-HVIT_BLAA)+(currG-HVIT_GRONN)*(currG-HVIT_GRONN)+ (currR-HVIT_ROD)*(currR-HVIT_ROD)<12000){
							hitCounterWhite++;
						}
						break;
					case BLUE:
						if((currB-BLAA_BLAA)*(currB-BLAA_BLAA)+(currG-BLAA_GRONN)*(currG-BLAA_GRONN)+ (currR-BLAA_ROD)*(currR-BLAA_ROD)<12000){
							hitCounterColored++;
						}
						else if((currB-HVIT_BLAA)*(currB-HVIT_BLAA)+(currG-HVIT_GRONN)*(currG-HVIT_GRONN)+ (currR-HVIT_ROD)*(currR-HVIT_ROD)<12000){
							hitCounterWhite++;
						}
						break;
					case WHITE:
						if((currB-HVIT_BLAA)*(currB-HVIT_BLAA)+(currG-HVIT_GRONN)*(currG-HVIT_GRONN)+ (currR-HVIT_ROD)*(currR-HVIT_ROD)<6000){
							hitCounterWhite++;
						}
						break;
					default:
						break;
				}
			}
		}
mean_R = mean_R/pixels;
mean_G = mean_G/pixels;
mean_B = mean_B/pixels;
int red_closeness   = (mean_R-ROD_ROD)*(mean_R-ROD_ROD)+(mean_G-ROD_GRONN)*(mean_G-ROD_GRONN)+ (mean_B-ROD_BLAA)*(mean_B-ROD_BLAA);
int blue_closeness  = (mean_R-BLAA_ROD)*(mean_R-BLAA_ROD)+(mean_G-BLAA_GRONN)*(mean_G-BLAA_GRONN)+ (mean_B-BLAA_BLAA)*(mean_B-BLAA_BLAA);
int white_closeness = (mean_R-HVIT_ROD)*(mean_R-HVIT_ROD)+(mean_G-HVIT_GRONN)*(mean_G-HVIT_GRONN)+ (mean_B-HVIT_BLAA)*(mean_B-HVIT_BLAA);
int ballColor;


                printf("closeness r b w: %i,%i,%i team_color:%i \r\n",red_closeness,blue_closeness,white_closeness,color);
		printf("mean RGB: %i,%i,%i\r\n",mean_R,mean_G,mean_B);

		if(red_closeness<blue_closeness){
		   if(red_closeness<white_closeness) {
			ballColor = RED;
			printf(" red ");
		   }
		   else{
			ballColor = WHITE;
			printf(" white ");
		   }
		}
		else{
                   if(blue_closeness<white_closeness)  {
                        ballColor = BLUE;
                        printf(" blue ");
                   }
                   else  {
                        ballColor = WHITE;
                        printf(" white ");
                   }
		}

		if(!(ballColor == color || ballColor == WHITE)){
			printf("Ball, men feil farge");
		}
		else{
			#ifdef USE_GUI
			cvRectangle(im,cvPoint(startX,startY),cvPoint(endX,endY),CV_RGB(255,0,0),1,8,0);
			#endif
			printf("%i,%i",cvRound(p[1]),cvRound(p[0]));
			if(finnBestBall(cvPoint(cvRound(p[1]),cvRound(p[0])))){
				braBall = 1;
				ball->x=bestball.x;
		  	 	ball->y = bestball.y;
				ball->type = ballColor;
			}
		}

		hitCounterColored = 0;
		hitCounterWhite = 0;
	}

		if(braBall){
#ifdef PRINT
			printf("Vi har en bra ball!");
#endif
			funnet.x= ball->x;
			funnet.y= ball->y;
			funnet_R = getWorldPosFromPixel(funnet, 1);
			ball->x= funnet_R.x;
			ball->y= funnet_R.y;
		//	ball->type = BALL;
		}
		else {
		   ball->type = NOTHING;
		   ball->x = 0;
		   ball->y = 0;
		}

#ifdef USE_GUI
	cvShowImage(window,im);
#endif


cvClearSeq( circles );
cvReleaseMemStorage( &storage );

cvReleaseImage(&gray);


#ifdef PRINT

	printf("x: %i, y: %i \n\r \r\n \r\n", ball->x, ball->y);
#endif
	if(ball->x <= 0 || ball->x > 1000 || ball->y < -1000 || ball->y > 1000){
		return 0;
	}
	else{
		return 1;
	}


}

bool findRobot(cv_observation *ball){

   int i;
	int r_top,g_top,b_top;
	int r_bunn,g_bunn,b_bunn;
	int j, k;
	uchar currB,currG,currR;
	int braBall=0;
	int startX,endX,startY,endY;
	float radius,s;
	int hitCounterColored = 0;
	int hitCounterWhite = 0;

	bestball.x=480;
	bestball.y=640;
	im =cvCreateImage(size, IPL_DEPTH_8U, 3);

	CvMemStorage* storage = cvCreateMemStorage(0);
	capture();

	gray = cvCreateImage( cvGetSize(im), 8, 1 );
	cvCvtColor( im, gray, CV_BGR2GRAY );
	cvSmooth( gray, gray, CV_GAUSSIAN, 9, 9 ); // smooth it, otherwise a lot of false circles may be detected
	circles = cvHoughCircles(gray, storage, CV_HOUGH_GRADIENT, DP, MIN_DIST, PARAM_1, PARAM_2, MIN_R, MAX_R);

			r_top = ROD_ROD;
			g_top = ROD_GRONN;
			b_top = ROD_BLAA;

			r_bunn = 0;
			g_bunn = 0;
			b_bunn = 0;

	CvPoint funnet = cvPoint(0,0);
	CvPoint funnet_R = cvPoint(0,0);
		int halvveis;
	for( k = 0; k < circles->total; k++ )
	{
		float* p = (float*)cvGetSeqElem( circles, k );
	#ifdef USE_GUI
		cvCircle( im, cvPoint(cvRound(p[0]),cvRound(p[1])), cvRound(p[2]), CV_RGB(255,0,0), 3, 8, 0 );
	#endif
		radius = 0.85*p[2];
		s = 2*radius*cos(45*M_PI/180);
		//printf("Radius: %i\n\r",s);
		startX = (int) (cvRound(p[0]) - 0.5*s);
		startY = (int) (cvRound(p[1]) + 0.5*s);
		endX = (int) (cvRound(p[0]) + 0.5*s);
		endY = (int) (cvRound(p[1]) - 0.5*s);
	#ifdef PRINT
		printf("Ball nr: %i ---> startX: %i, endX: %i, startY: %i, endY: %i\n\r",k,startX,endX,startY,endY);
		#endif
		halvveis = (startY-endY)/2;
		printf("halvveis: %i\n\r",halvveis);
		for(i=startY;i>endY+halvveis;i--){
			for(j=startX;j<endX;j++){
				currR = ((uchar *)(im->imageData + i*im->widthStep))[j*im->nChannels + 2];
				currG = ((uchar *)(im->imageData + i*im->widthStep))[j*im->nChannels + 1];
				currB = ((uchar *)(im->imageData + i*im->widthStep))[j*im->nChannels + 0];

					if((currR>0.8*(currG+currB)) && (currG<180) && (currB<180)){
							hitCounterColored++;
						}
					else if(currR>130 && currG>130 && currB>130){
						hitCounterWhite++;
					}

				((uchar *)(im->imageData + i*im->widthStep))[j*im->nChannels + 2]=0;
				((uchar *)(im->imageData + i*im->widthStep))[j*im->nChannels + 1]=255;
				((uchar *)(im->imageData + i*im->widthStep))[j*im->nChannels + 0]=0;
			}
		}
		for(i=startY-halvveis;i>endY;i--){
			for(j=startX;j<endX;j++){
				currR = ((uchar *)(im->imageData + i*im->widthStep))[j*im->nChannels + 2];
				currG = ((uchar *)(im->imageData + i*im->widthStep))[j*im->nChannels + 1];
				currB = ((uchar *)(im->imageData + i*im->widthStep))[j*im->nChannels + 0];

					if((currR>0.8*(currG+currB)) && (currG<180) && (currB<180)){
							hitCounterColored++;
						}
					else if(currR>130 && currG>130 && currB>130){
						hitCounterWhite++;
					}
				((uchar *)(im->imageData + i*im->widthStep))[j*im->nChannels + 2]=255;
				((uchar *)(im->imageData + i*im->widthStep))[j*im->nChannels + 1]=255;
				((uchar *)(im->imageData + i*im->widthStep))[j*im->nChannels + 0]=0;
			}
		}
		if((hitCounterColored > 0.75*((endX-startX)*(startY-endY))) || (hitCounterWhite > 0.75*((endX-startX)*(startY-endY)))){
			cvRectangle(im,cvPoint(startX,startY),cvPoint(endX,endY),CV_RGB(255,0,0),1,8,0);
		}
		hitCounterColored = 0;
		hitCounterWhite = 0;
	}

		if(braBall){
#ifdef PRINT
			printf("Vi har en bra ball, og den er på posisjon:  %i %i\n\r",ball->x,ball->y);
#endif
			funnet.x= ball->x;
			funnet.y= ball->y;
			funnet_R = getWorldPosFromPixel(funnet, 1);
			ball->x= funnet_R.x;
			ball->y= funnet_R.y;
			ball->type = BALL;
		}
		else {
		   ball->type = NOTHING;
		   ball->x = 0;
		   ball->y = 0;
		}

#ifdef USE_GUI
	cvShowImage(window,im);
#endif


cvClearSeq( circles );
cvReleaseMemStorage( &storage );

cvReleaseImage(&gray);


#ifdef PRINT
	printf("x: %i, y: %i \n\r", ball->x, ball->y);
#endif
	if(ball->x <= 0 || ball->x > 1000 || ball->y < -1000 || ball->y > 1000){
		return 0;
	}
	else{
		return 1;
	}


}

