#include "gatewayBallSorting.h"

void gatewayWheelReady(MessageHandler *plansysMessageHandler){
	cout << "Wheel ready!" << endl;
	plansysMessageHandler->sendCommand( MINOR_WHEEL_READY, PRIORITY_HIGHEST );
}

void gatewayBallStored(__u8 *mdata, MessageHandler *plansysMessageHandler){
	int i;
	ball_message new_ball_message;
	for(i = 0; i < 8; i++){
		new_ball_message.data[i] = mdata[i];
	}
	plansysMessageHandler->sendMessage((char *)&new_ball_message, (int)sizeof(ball_message), MINOR_BALL_STORED, PRIORITY_HIGH );
}

void gatewayBallsReleased(__u8 *mdata, MessageHandler *plansysMessageHandler){
	int i;
	ball_message new_ball_message;
	for(i = 0; i < 8; i++){
		new_ball_message.data[i] = mdata[i];
	}
	plansysMessageHandler->sendMessage((char *)&new_ball_message, (int)sizeof(ball_message), MINOR_BALLS_RELEASED, PRIORITY_HIGH );
}

void gatewayColorDetected(__u8 *mdata, MessageHandler *plansysMessageHandler){
	int i;
	ball_message new_ball_message;
	for(i = 0; i < 8; i++){
		new_ball_message.data[i] = mdata[i];
	}
	plansysMessageHandler->sendMessage((char *)&new_ball_message, (int)sizeof(ball_message), MINOR_COLOR_DETECTED, PRIORITY_HIGH );
}

void gatewayReleaseBalls(pmq_message *pm){
	int i;
	TPCANMsg canSendStruct;
	canSendStruct.ID = CAN_ADDR_RELEASE_BALLS;
	canSendStruct.MSGTYPE = MSGTYPE_STANDARD;
	canSendStruct.LEN = 0x08;
	for(i=0;i<8;i++){
		canSendStruct.DATA[i] = pm->data[i];
	}
	can_send_message( &canSendStruct );
}

void gatewayColorAck(pmq_message *pm){
	int i;
	TPCANMsg canSendStruct;
	canSendStruct.ID = CAN_ADDR_COLOR_ACK;
	canSendStruct.MSGTYPE = MSGTYPE_STANDARD;
	canSendStruct.LEN = 0x08;
	for(i=0;i<8;i++){
		canSendStruct.DATA[i] = pm->data[i];
	}
	printf("182 sent\n\r");
	can_send_message( &canSendStruct );
}

void gatewaySetArms(pmq_message *pm){
	int i;
	//cout << "Position arms" << endl;
	printf("PosArms: %X, %X, %X\n\r", pm->data[0], pm->data[1], pm->data[2]);
	TPCANMsg canSendStruct;
	canSendStruct.ID = CAN_ADDR_SET_ARMS;
	canSendStruct.MSGTYPE = MSGTYPE_STANDARD;
	canSendStruct.LEN = 3;
	for(i=0;i<3;i++){
		canSendStruct.DATA[i] = pm->data[i];
	}
	can_send_message( &canSendStruct );
}

void gatewaySendSwitchInterrupt(__u8 *mdata, MessageHandler *plansysMessageHandler){
	switch_message new_switch_message;
	new_switch_message.data = mdata[0];
	plansysMessageHandler->sendMessage((char *)&new_switch_message, (int)sizeof(switch_message), MINOR_CMD_SWITCHES, PRIORITY_HIGH );
}
