#include "gatewayCommands.h"

void gatewayReceiveCommands(pmq_message *pm){
	int i;
	TPCANMsg canSendStruct;
	proxy_commands local_proxy_command;
	memcpy((void *)(&local_proxy_command), (void *)pm->data, sizeof(proxy_commands));

	canSendStruct.ID = local_proxy_command.commandType;
	canSendStruct.MSGTYPE = MSGTYPE_STANDARD;
	canSendStruct.LEN = local_proxy_command.length;
	for(i = 0; i < local_proxy_command.length; i++){
		canSendStruct.DATA[i] = local_proxy_command.data[i];
	}
	can_send_message( &canSendStruct );

}

void gatewayReceiveCommand(pmq_message *pm) {

	if( pm->minor == MINOR_SET_LED_TEAM_COLOR_RED ) {
		TPCANMsg canSendStruct;
		cout << "MINOR_SET_LED_TEAM_COLOR_RED" << endl;
		canSendStruct.ID = CAN_SET_LED_TEAM_COLOR_RED;
		canSendStruct.MSGTYPE = MSGTYPE_STANDARD;
		canSendStruct.LEN = 0;

		can_send_message( &canSendStruct );
	}
	else if( pm->minor == MINOR_SET_LED_TEAM_COLOR_BLUE ) {
		cout << "MINOR_SET_LED_TEAM_COLOR_BLUE" << endl;
		TPCANMsg canSendStruct;
		canSendStruct.ID = CAN_SET_LED_TEAM_COLOR_BLUE;
		canSendStruct.MSGTYPE = MSGTYPE_STANDARD;
		canSendStruct.LEN = 0;

		can_send_message( &canSendStruct );
	}
	else {
		printf("Unhandled command in proxyCommands.cpp");
	}

}

int gatewayInitTimeMessage( MessageHandler *plansysMessageHandler ) {
	plansysMessageHandler->sendCommand( MINOR_CMD_SYSTEM_GO, PRIORITY_HIGHEST );
	return 0;
}
/**
 * NEW CODE STARTS HERE
 */
int gatewayLowBattery( MessageHandler *plansysMessageHandler ) {
	plansysMessageHandler->sendCommand( MINOR_CMD_LOW_BATTERY, PRIORITY_HIGHEST );
	printf("Critically low battery!\n\r");
	return 0;
}

/**
 * NEW CODE ENDS HERE
 */
int gatewaySendCommand(MessageHandler *sysMessageHandler, int minor, int priority ) {
	sysMessageHandler->sendCommand( minor, priority );
	return 0;
}

