/**
* Eurobot 2007
* Proxy config
*
*/

#ifndef PROXYCONFIG_H
#define PROXYCONFIG_H

//#include <list>

/**
* CAN message ID defines
* Configuration using static look-up table.
*/



#define CAN_HIGHEST_ID 0x7FF
#define CAN_GAME_STOP 0x05
#define CAN_LOW_BATTERY					0x06
#define CAN_INIT_GAME_TIME 0x10
#define CAN_RESET_GAME 0x11

#define CAN_INTERRUPT_SWITCHES	0x12

// Collision detection 0x80 - 0x8F
#define CANID_COLLISION_DETECTED 0x80
#define CANID_COLLISION_SLAVE_MASTER_COMMANDS 0x81
#define CANID_RANGE_MEASUREMENTS 0x84
#define CANID_REQUEST_MEASUREMENTS 0x85

// flashes sensor 2 - 2 0 0 0 0 0 0 0
// 0 0 0 1 4 1 1 0 // Flashes all one time
// 0 0 0 1 4 1 5 0 // Flashes all five time
#define CANID_FLASH_SENSOR_BOARD_LED 0x86
#define CANID_ENABLE_SENSOR_LEDS 0x87
#define CANID_SET_COLLISION_THRESHOLDS 0x88
#define CANID_SET_INTERRUPT_REFRESH_INTERVAL 0x89
#define CANID_ENABLE_SENSOR_LIGHTS 0x87
//interrupt refresh interval er hvor ofte interrupt resendes ved kollisjon

// MOTOR
#define CAN_ADDR_MOTOR_MAIN 0x110 // 0x90

// Motor RIGHT 0x115 - 0x120
#define CAN_ADDR_MOTOR_RIGHT_SETDIR 0x116 //0x130
#define CAN_ADDR_MOTOR_RIGHT_SETSPEED 0x117 //0x131
#define CAN_ADDR_MOTOR_RIGHT_READ_QUAD 0x118 //0x201
#define CAN_ADDR_MOTOR_RIGHT_RETURN_QUAD 0x71

#define CAN_ADDR_MOTOR_DRIVER_INIT 0x11D
#define CAN_ADDR_MOTOR_EMERGENCY_STOP 0x11E
#define CAN_ADDR_MOTOR_INIT_QUAD 0x11F

#define CAN_ADDR_QUAD_INIT 0x400


// Motor LEFT 0x111 - 0x114
#define CAN_ADDR_MOTOR_LEFT_SETDIR 0x111 //0x132
#define CAN_ADDR_MOTOR_LEFT_SETSPEED 0x112 //0x133
#define CAN_ADDR_MOTOR_LEFT_READ_QUAD 0x113 //0x200
#define CAN_ADDR_MOTOR_LEFT_RETURN_QUAD 0x70

// IO CARD Quadrature 0x130 - 0x13F
//#define CAN_RESET_GAME 0x11
#define CAN_CMD_SET_TEAM_COLOR_RED 0x16 //0x130
#define CAN_CMD_SET_TEAM_COLOR_BLUE 0x15 //0x131

#define CAN_ADDR_READ_DUAL_QUAD 0x133
#define CAN_ADDR_INIT_DUAL_QUAD 0x13F
#define CAN_ADDR_RETURN_DUAL_QUAD 0x72

#define CAN_RESET_VOLTAGE_ALARM 0x136
#define CAN_SET_LED_TEAM_COLOR_RED 0x135
#define CAN_SET_LED_TEAM_COLOR_BLUE 0x134
#define CAN_ADDR_RELEASE_BATTERY 0x13A // Battery Sort
#define CAN_ADDR_BATTERY_RELEASED 0x13B //Battery Sort

// Bottle Box Sort 0x180 - 0x18F
/*#define CAN_ADDR_PICK_UP_BOTTLE_BOX 0x183
#define CAN_ADDR_RELEASE_BOTTLE_BOX 0x184
#define CAN_ADDR_BOTTLE_BOX_RELEASED 0x185
#define CAN_ADDR_BOTTLE_BOX_TYPE 0x186
#define CAN_ADDR_BOTTLE_BOX_STOP_GAME 0x187
#define CAN_ADDR_PICK_UP_BOTTLE_SUCCESS 0x53
#define CAN_ADDR_PICK_UP_BOX_SUCCESS 0x189
#define CAN_ADDR_BOTTLE_BOX_PICK_UP_FAILURE 0x18A
#define CAN_ADDR_BOTTLE_BOX_ARM_DOWN 0x18B
*/
#define CAN_ADDR_SET_ARMS	0x180
#define CAN_ADDR_COLOR_DETECTED	0x181
#define CAN_ADDR_COLOR_ACK	0x182
#define CAN_ADDR_WHEEL_READY	0x183
#define CAN_ADDR_BALL_STORED	0x184
#define CAN_ADDR_RELEASE_BALLS	0x185
#define CAN_ADDR_BALLS_RELEASED	0x186
#define CAN_ADDR_RESET_SORTER	0x188
#define CAN_ADDR_STOP_SORTER	0x189

#define CAN_ADDR_POSITIONING_BEACON_ANGLES 0x120
#define CAN_ADDR_POSITIONING_BEACON_REQUEST 0x121
#define CAN_ADDR_POSITIONING_UPDATE_ANGLES 0x122


/**
* Posix message address defines
*/
#define POSIX_HIGHEST_ADDR 0x400

#define ADDR_BROADCAST 0x00
#define INTERNAL_ADDR_NAVSYS 0x01
#define INTERNAL_ADDR_PLANSYS 0x02
#define INTERNAL_ADDR_CVSYS 0x03
#define INTERNAL_ADDR_LOGSYS 0x04
#define INTERNAL_ADDR_PROXY 0x05

#define INTERNAL_ADDR_RS232 0x08
#define INTERNAL_ADDR_GPIO 0x10

#define EXT_ADDR_NAVSYS 0x150
#define EXT_ADDR_ANGLOMETER 0x151
#define EXT_ADDR_COLLISIONSENSE 0x152



// Motor RIGHT
#define EXT_ADDR_MOTOR_RIGHT_SETDIR 0x130
#define EXT_ADDR_MOTOR_RIGHT_SETSPEED 0x131
#define EXT_ADDR_MOTOR_RIGHT_READ_QUAD 0x200

// Motor LEFT
#define EXT_ADDR_MOTOR_LEFT_SETDIR 0x132
#define EXT_ADDR_MOTOR_LEFT_SETSPEED 0x133
#define EXT_ADDR_MOTOR_LEFT_READ_QUAD 0x204


// Define interfaces
#define INTERFACE_ALL 		0x20
#define INTERFACE_CAN 		0x21
#define INTERFACE_POS 		0x22
#define INTERFACE_CV 		0x23
#define INTERFACE_PLANSYS 	0x24



#endif



