#ifndef PROXY_MOTOR_CONTROL_H
#define PROXY_MOTOR_CONTROL_H

//****************************************************************************
// Gunnar Kjemphol
// Eurobot 2007
//
//****************************************************************************

// INCLUDES
#include <pthread.h>
#include <cstdio>
#include <cstdlib>
#include <cerrno>
#include <ctype.h>
#include <unistd.h>   // exit
#include <signal.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>    // O_RDWR

#include <libpcan.h>
#include <pcan.h>

#include <math.h>

#include "main.h"
//#include "Proxy.h"
#include "gatewayConfig.h"
#include "posix_message_config.h"
#include "MessageHandler.h"
#include "posix_message_queue.h"
#include "can_bus.h"
#include "observation_structs.h"
#include "common.h"


int quad_init();

void gatewayUpdateBeaconAngles(pmq_message *pm);

void gatewayReceiveMotorControl(pmq_message *pm);

int gatewayRightReturnQuad(__u8 *mdata, MessageHandler *navsysMessageHandler);
int gatewayLeftReturnQuad(__u8 *mdata, MessageHandler *navsysMessageHandler);
int gatewayReturnDualQuad(__u8 *mdata, MessageHandler *navsysMessageHandler);

#endif


