#ifndef OBSERVATION_STRUCTS_H
#define OBSERVATION_STRUCTS_H


// Observers are always observing in a coordinate sys. defined from BODY.
typedef struct odometry_observation {
	int right;
	int left;
};

typedef struct distance_observation {
	int observer_feature_id;
	int target_feature_id;
	int distance;
};

typedef struct angle_observation {
	int observer_feature_id;
	int target_feature_id;
	int angle;
};


typedef struct motor_control_message {
	int m1;
	int m2;
};

typedef struct beacon_angles{
	double b1;
	double b2;
	double b3;
};


typedef struct beacon_measure{
	int start;
	int type;
};

typedef struct cv_observation {
  short type; // BOX FLASKE BATTERI BATTERY_BIN
  short x;
  short y;
  short ret;
  short teamColor;

};

typedef struct ai_waypoint {
  short id;
  int tag;
  short x_l;
  short y_l;
  float psi_l;
  short circle_of_acceptance;
};

typedef struct speed_limit {
  double u_b; // Fwd speed m/s
  double r_b; // Rotation speed rad/s
};

typedef struct speed {
  double u_b; // Fwd speed m/s
  double r_b; // Rotation speed rad/s
};

typedef struct proxy_message {
 char teamColor;

};

typedef struct proxy_commands {
  char commandType;
  char length;
  char data[8];

};

typedef struct collision_detection_message {
	unsigned char data[8];
};

typedef struct ball_message{
	unsigned char data[8];
};

typedef struct switch_message{
	unsigned char data;
};

#define NAVSYS_NAME "navsys"
#define CVSYS_NAME "cvsys"
#define PLANSYS_NAME "plansys"
#define LOGSYS_NAME "logsys"
#define PROXY_NAME "proxy"
#define NAVSYS_ID 1
#define CVSYS_ID 2
#define PLANSYS_ID 3
#define LOGSYS_ID 4
#define PROXY_ID 5

#define MAX_DEBUG_TEXT_LENGTH 25
typedef struct debug_text_message {
	unsigned int systemId;	// Where is the message from...
	unsigned int length;
	char text[MAX_DEBUG_TEXT_LENGTH];
};


#endif

