#include <pthread.h>

class Mutex { 
	public:
		/**
		* Initialize the mutex.
		*/
		Mutex() {
			 pthread_mutex_init(&mutex, NULL);	// Could use static instead..
		}

		/**
		* Simply destroy the mutex.
		*/
		~Mutex() {
			 pthread_mutex_destroy(&mutex);
		}

		/**
		* void because we are using default mutex type (no errors returned).
		*/
		void lock() {
			pthread_mutex_lock(&mutex);
		}

		/**
		* void because errors cant happen here.
		*/
		void unlock() {
			pthread_mutex_unlock(&mutex);
		}
 
		/**
		* Returns 0 on success, error value if Mutex already is locked.
		*/
		int	trylock() {
			return pthread_mutex_trylock(&mutex);
		}

	private:
		pthread_mutex_t mutex;
}; 
