#ifndef PIN_POINTED_RUNTIME_H
#define PIN_POINTED_RUNTIME_H

#include <iostream>
#include <string>
#include <stdlib.h>
#include <sys/time.h>   // Timers
#include <time.h>
#include <signal.h>     // Timers, signals
#include <unistd.h>		// Sleep

#include "config.h"
#include "constants.h"
#include "MessageHandler.h"
#include "NavsysXMLParser.h"
#include "EnvironmentMap.h"

#include "CoordinateTransform.h"
#include "RobotModel.h"


using namespace std;


// Timer interrupt rate (sample rate for positioning system)
#define UPDATE_RATE 40      // update speed in Hz

void timerHandler(int x);


// Message handler for messages through PMQ
MessageHandler *messageHandler;
MessageHandler *messageHandlerPlan;

// The robot model used
RobotModel *robotModel;


#endif
