#include "Observer.h"
#include "planner.h"

Balls::Balls(){
	InitializeBalls();
}

void Balls::InitializeBalls(){
	redBalls = 5;
	blueBalls = 5;
	redWhiteBalls = 5;
	blueWhiteBalls = 5;
	whiteRobotBalls = 0;
	redBlueRobotBalls = 0;
	lastBallColor = 1;
	extraWhiteBall = 0;
	extraColoredBall = 0;
}

void Balls::RemoveBall(int typeOfBall, int numberOfBalls){
	switch(typeOfBall){
		case RED_BALL:
			redBalls = redBalls - numberOfBalls;
			if(redBalls<0) redBalls = 0;
			break;
		case BLUE_BALL:
			blueBalls = blueBalls - numberOfBalls;
			if(blueBalls<0) blueBalls = 0;
			break;
		case RED_WHITE_BALL:
			redWhiteBalls = redWhiteBalls - numberOfBalls;
			if(redWhiteBalls<0) redWhiteBalls = 0;
			break;
		case BLUE_WHITE_BALL:
			blueWhiteBalls = blueWhiteBalls - numberOfBalls;
			if(blueWhiteBalls<0) blueWhiteBalls = 0;
			break;
		default:
			cout << "Wrong type of ball!" << endl;
			break;
	}
}

int Balls::GetNumberOfBalls(int typeOfBall){
	switch(typeOfBall){
		case RED_BALL:
			return redBalls;
			break;
		case BLUE_BALL:
			return blueBalls;
			break;
		case RED_WHITE_BALL:
			return redWhiteBalls;
			break;
		case BLUE_WHITE_BALL:
			return blueWhiteBalls;
			break;
		default:
			cout << "Wrong type of ball!" << endl;
			return -1;
			break;
	}
}

void Balls::AddRobotBalls(int typeOfBall, int numberOfBalls){
	switch(typeOfBall){
		case WHITE_ROBOT_BALL:
			whiteRobotBalls = whiteRobotBalls + numberOfBalls;
			if(whiteRobotBalls>5) whiteRobotBalls = 5;
			break;
		case RED_BLUE_ROBOT_BALL:
			redBlueRobotBalls = redBlueRobotBalls + numberOfBalls;
			if(redBlueRobotBalls>5) redBlueRobotBalls = 5;
			break;
		default:
			cout << "Wrong type of ball!" << endl;
			break;
	}
}

void Balls::RemoveRobotBalls(int typeOfBall, int numberOfBalls){
	switch(typeOfBall){
		case WHITE_ROBOT_BALL:
			whiteRobotBalls = whiteRobotBalls - numberOfBalls;
			if(whiteRobotBalls<0) whiteRobotBalls = 0;
			break;
		case RED_BLUE_ROBOT_BALL:
			redBlueRobotBalls = redBlueRobotBalls - numberOfBalls;
			if(redBlueRobotBalls<0) redBlueRobotBalls = 0;
			break;
		default:
			cout << "Wrong type of ball!" << endl;
			break;
	}
}

int Balls::GetNumberOfRobotBalls(int typeOfBall){
	switch(typeOfBall){
		case WHITE_ROBOT_BALL:
			return whiteRobotBalls;
			break;
		case RED_BLUE_ROBOT_BALL:
			return redBlueRobotBalls;
			break;
		case ALL:
			return whiteRobotBalls+redBlueRobotBalls;
			break;		
		default:
			cout << "Wrong type of ball!" << endl;
			return -1;
			break;
	}
}

void Balls::SetLastBallColor(int lastColor){
	lastBallColor = lastColor;
}

int Balls::GetLastBallColor(){
	return lastBallColor;
}

int Balls::GetNumberOfWhiteBallsToPickUp(){
	if(lastBallColor == WHITE_BALL){
		return 2;
	}
	else{
		return 3; //HACKHACKHACKHACKHACKHACK
	}
}

void Balls::SetExtraBall(int color, int numberOfBalls){
	if(color == WHITE_ROBOT_BALL){
		extraWhiteBall = numberOfBalls;
	}
	else if(color == RED_BLUE_ROBOT_BALL){
		extraColoredBall = numberOfBalls;
	}
}

int Balls::GetExtraBall(int color){
	if(color == WHITE_ROBOT_BALL){
		return extraWhiteBall;
	}
	else if(color == RED_BLUE_ROBOT_BALL){
		return extraColoredBall;
	}
}
