#ifndef HORIZONTAL_DISPENSER_STRATEGY_H
#define HORIZONTAL_DISPENSER_STRATEGY_H

#include <math.h>

#include "Observer.h"
#include "PlansysObservation.h"
#include "planner.h"
#include "waypoint.h"
#include "posix_message_config.h"
#include "init.h"

class HorizontalDispenserStrategy: public Observer {
  public:
	HorizontalDispenserStrategy( PlansysObservation * , int theTeamColor );
	~HorizontalDispenserStrategy();
	void Reset( int theTeamColor );
	void Update( int typeOfObservation );
	void UpdatePriority();
	int GetPriority();
	void PerformStrategy( MessageHandler *navsysMessageHandler, MessageHandler *proxysysMessageHandler, MessageHandler *cvsysMessageHandler  );
  
  private:
	int lastWaypointSent;	
	int lastWaypointReached;

	collision_detection_message collision_message;	
	
	int strategyDone;
	int collision;
	
	int board1, board2, board3;

	double internalState;
	double distance;
	double distance_x;
	double distance_y;
	int timeLeft;
	int priority;
	
	int state;
	enum{
		INIT,
		RED_DISPENSER,
		BLUE_DISPENSER,
		WHITE_DISPENSER,
		WHITE_BALL
		};
	
	PlansysObservation *_subject;
	ai_waypoint ai_waypoint_3d;
	ai_waypoint last_ai_waypoint;
	ai_waypoint activeWaypoint;

	cv_observation my_cv_observation;
	proxy_message my_proxy_message;
	time_message local_time_message;
	control_struct local_control_struct;
};

#endif
