#ifndef MOTOR_AI_H
#define MOTOR_AI_H

#include "Observer.h"
#include "PlansysObservation.h"
#include "planner.h"
#include "waypoint.h"
#include "posix_message_config.h"
#include "init.h"

class MotorAi: public Observer {
  public:
    MotorAi( PlansysObservation * , int theTeamColor );
    ~MotorAi();
    void Update( Subject *, int typeOfObservation);
    int GetPriority();
    int AgentGlobalPriority();
    int GetAction( control_struct *ai_control_struct );
    int SetAgentActive( int active );
    int StrategyInterrupted();
    //int GetInterruptAction(interrupt_control_struct *interrupt_control);


  private:
    int agentPriority;
    int inAction;
    int activeStrategy;
    int lastWaypointReached;
    PlansysObservation *_subject; // reference to subject
    ai_waypoint ai_waypoint_3d;
    proxy_message my_proxy_message;
    cv_observation my_cv_observation;
    collision_detection_message collision_message;
    control_struct local_control_struct;

    timeval collision_timer;
    double collision_time_value_1;
    double collision_time_value_2;
    int collision_counter;

};

#endif
