#ifndef OBSERVER_H
#define OBSERVER_H

#include <list>
#include <iostream>
#include <vector>

#include "planner.h"
#include "MessageHandler.h"

// Defines

using namespace std;

class Subject;

class Observer {
  public:
	Observer( );
	~Observer();
	virtual void Reset( int teamColor ) = 0;
	virtual void Update(int typeOfObservation) = 0;
	virtual int GetPriority() = 0;
	virtual void PerformStrategy( MessageHandler *navsysMessageHandler, MessageHandler *proxysysMessageHandler, MessageHandler *cvsysMessageHandler ) = 0;
	virtual void UpdatePriority() = 0;
	int teamColor;

  private:
};

class Subject {
  public:
	Subject() {};
	~Subject() {};
	void Attach( Observer* );
	void Detach( Observer* );
	void Notify(int typeOfObservation);
	
	vector<Observer *> _observers;
  private:

  protected:
};


#endif
