#ifndef START_STRATEGY_H
#define START_STRATEGY_H

#include <math.h>

#include "Observer.h"
#include "PlansysObservation.h"
#include "planner.h"
#include "waypoint.h"
#include "posix_message_config.h"
#include "init.h"
#include "observation_structs.h"

class StartStrategy: public Observer {
  public:
	StartStrategy( PlansysObservation * , int theTeamColor );
	~StartStrategy();
	void Reset( int theTeamColor );
	void Init();
	void Update( int typeOfObservation );
	void UpdatePriority();
	int GetPriority();
	void CheckForCollision(MessageHandler *navsysMessageHandler);
	void CheckBall( MessageHandler *proxysysMessageHandler, MessageHandler *navsysMessageHandler, int nextBallColor);
	void PerformStrategy( MessageHandler *navsysMessageHandler, MessageHandler *proxysysMessageHandler, MessageHandler *cvsysMessageHandler  );
  
  private:
	int lastWaypointSent;	
	int lastWaypointReached;
	int newBall;
	int ballStored;
	int wheelReady;

	int ballCheck;
	
	collision_detection_message collision_message;		
	int collision;
	int strategyDone;
	int firstBall;	

	int board1, board2, board3, board4, board5;
	int boards[NUMBER_OF_BOARDS];
	int ballColor;

	double internalState;
	double distance;
	double distance_x;
	double distance_y;
	int timeLeft;
	int priority;
	
	int state;
	enum{
		INIT,
		FIRST_WHITE_BALL,
	};

	PlansysObservation *_subject; 
	ai_waypoint ai_waypoint_3d;
	ai_waypoint last_ai_waypoint;
	ai_waypoint activeWaypoint;

	cv_observation my_cv_observation;
	proxy_message my_proxy_message;
	ball_message my_ball_message;
	time_message local_time_message;
};

#endif
