#ifndef PLANNER_H
#define PLANNER_H

#include "observation_structs.h"
#include <vector>
#include <signal.h>

#include "Balls.h"

#define GLOBAL_WAYPOINT			0
#define RELATIVE_WAYPOINT		1

//#define VOLTAGE_SURVEILLANCE		1

//#define ADJUSTING			1
#define SWITCH_ADJUST			1
#define ANTI_COLLISION_ACTIVE		1
#define REAR_ANTI_COLLISION_ACTIVE	2
#define NUMBER_OF_BOARDS		5
#define FRONT_LEFT_ANTI_COLLISION	1
#define FRONT_RIGHT_ANTI_COLLISION	5
//#define REAR_ANTI_COLLISION		6
//#define LEFT_ADJUST			0
//#define RIGHT_ADJUST			4
#define BOARD_NOT_ACTIVE		50

#define ANTI_COLLISION_STRATEGY		0
#define START_STRATEGY			1
#define CONTAINER_STRATEGY		2
#define HORIZONTAL_DISPENSER_STRATEGY	3
#define COOLED_CONTAINER_STRATEGY	4
#define SEARCH_FOR_BALL_STRATEGY	5
#define WHITE_DISPENSER_STRATEGY	6
#define RED_BLUE_DISPENSER_STRATEGY	7

#define WHITE_BALL			0
#define RED_BALL			1
#define BLUE_BALL			2
#define COLORED_BALL			3
#define RED_WHITE_BALL			4
#define BLUE_WHITE_BALL			5
#define WHITE_ROBOT_BALL		6
#define RED_BLUE_ROBOT_BALL		7
#define ALL				8
#define MAX_NUMBER_OF_BALLS		5

#define ARMS_OPEN			0
#define ARMS_READY			60
#define ARMS_CLOSED			88

#define MOTOR_ON			100
#define MOTOR_OFF			0
#define BELTS_DIRECTION_IN		0
#define BELTS_DIRECTION_OUT		1

#define BELT_INPUT_TIMER		800000

#define COLLISION_LEFT			0
#define COLLISION_RIGHT			1
#define COLLISION_FRONT			2
#define COLLISION_REAR			3

#define LEFT				0
#define RIGHT				1
#define FRONT				2
#define REAR				3

#define WAYPOINT_SAFETY_DISTANCE	700

#define BUFFER_SIZE			3

#define WHITE				0
#define RED				1
#define BLUE				2

#define MAX_NUMBER_OF_TRIES		3

#define NUMBER_OF_SUPPORT_WAYPOINTS	3
#define ANTI_COLLISON_ANGLE_CHANGE	0

#define STRATEGY_WHILE_DELAY		10000

void catch_sighup(int sig_num);

//int teamColor = 0;

const int GAME_TIME = 89;
const int GAME_TIME_MESSAGE = 200;
const int TIME_OUT = 3;
const int DISPENSER_TIME_OUT = 3;
const int COLLISION_THRESHOLD = 26;
const int COLLISION_STOP = 22;
const int ADJUST_COLLISION_TIMER = 1500000;
const int DISTANCE_MEASURE_THRESHOLD = 22;
const int MINIMUM_DISPENSER_STOP_THRESHOLD = 10;

const int ANTI_COLLISION_DISTANCE = 300; //mm
const int ANTI_COLLISION_DISTANCE_FRONT = 400;
const int TABLE_SIZE_X = 3000;
const int TABLE_SIZE_Y = 2100;

const int FALSE = 0;
const int TRUE = 1;

const double MAX_SPEED_MPS = 10.0;

const int POSITION_TIMER_BUFFER_SIZE = 20;

extern Balls balls;

typedef struct time_message {
  int gameTime;
  int timeLeft;

};

typedef struct control_struct {
  bool setMaxSpeed;
  double maxSpeed_mps;
  bool clearWaypoints;

  std::vector<int> command;
  /**
   * Pointer to waypoint struct
   */
  std::vector<ai_waypoint> _ai_waypoint;
  /**
   * Pointer to waypoint struct relative robot
   */
  std::vector<ai_waypoint> _ai_waypoint_rel_robot;
};

#endif
