#include "posixCommunication.h"

extern int teamColor;
extern int receivedTeamColor;

extern int collisionDetect;

extern int askForCvObservationFlag;
extern int receivedGameStartMessage;
extern int gameResetMessageTimer;
extern int gameResetMessageMain;
extern int gameFirstStart;
extern int lowBattery;
extern int counter;

extern PlansysObservation plansysObs;

int positionReceived = FALSE;
/**
 * **************************************************************************** *
 * Request and send functions                                                   *
 * **************************************************************************** *
 */
int SendInitPosition( MessageHandler *navsysMessageHandler ) {
	posix_robot_state_3dof robot_init_state_3dof;
	//PASS PÅ TEAM-FARGE; KAN VERA FEIL!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	if( teamColor == TEAM_COLOR_BLUE ) {
		robot_init_state_3dof.x_l = 250;
		robot_init_state_3dof.y_l = 250;
		robot_init_state_3dof.u_b = 0;
		robot_init_state_3dof.psi_l = (M_PI/4);
		robot_init_state_3dof.r_b = 0;
	}
	else if ( teamColor == TEAM_COLOR_RED ) {
		robot_init_state_3dof.x_l = TABLE_SIZE_X - 250;
		robot_init_state_3dof.y_l = 250;
		robot_init_state_3dof.u_b = 0;
		robot_init_state_3dof.psi_l = ((3*M_PI)/4);
		robot_init_state_3dof.r_b = 0;	
	}
	else {
		cout << "ALERT: No teamColor recieved " << endl;
		cout << "Wath IF !!! " << endl;
	}
	navsysMessageHandler->sendMessage( (char *)&robot_init_state_3dof, (int)sizeof(posix_robot_state_3dof), MINOR_NAVSYS_SET_POSITION, PRIORITY_HIGHEST );
	counter = 1;
	return 0;
}

void sendNewPosition( MessageHandler *navsysMessageHandler, ai_waypoint *position_update ){
	posix_robot_state_3dof positionUpdate;
	positionUpdate.x_l = position_update->x_l;
	positionUpdate.y_l = TABLE_SIZE_Y-55;
	positionUpdate.psi_l = 90*M_PI/180;
	navsysMessageHandler->sendMessage( (char *)&positionUpdate, (int)sizeof(posix_robot_state_3dof), MINOR_NAVSYS_SET_POSITION, PRIORITY_HIGHEST );
}

int flashTheSensorBoardLeds( MessageHandler *proxysysMessageHandler ){
	collision_detection_message collision_message;
	proxysysMessageHandler->sendMessage( (char *)&collision_message, (int)sizeof(collision_detection_message), MINOR_FLASH_SENSOR_BOARD_LED, PRIORITY_NORMAL );
	return 0;
}

int askForCvObservation( MessageHandler *cvsysMessageHandler) {
	cv_observation my_cv_observation;
	my_cv_observation.type = BALL;
	my_cv_observation.x = 0;
	my_cv_observation.y = 0;
	my_cv_observation.ret = 0;
	my_cv_observation.teamColor = teamColor;
	cvsysMessageHandler->sendMessage( (char *)&my_cv_observation, (int)sizeof(cv_observation), MINOR_CV_OBSERVATION, PRIORITY_VERY_HIGH );
	return 0;
}
  
/**
* **************************************************************************** *
* Recieve functions                                                            *
* **************************************************************************** *
*/

void receiveCollisionDetectionStruct(pmq_message *pm){
	pmq_message my_posix_message;
	memcpy((void *)(&my_posix_message),( void * )pm, sizeof(pmq_message));
	plansysObs.NewObservation(my_posix_message, MINOR_COLLISION_DETECTED);
}

void receiveCvObservaton(pmq_message *pm){
	pmq_message my_posix_message;
	memcpy((void *)(&my_posix_message),( void * )pm, sizeof(pmq_message));
	cout << " \n \n RecieveCvObservation \n \n" << endl;
	plansysObs.NewObservation(my_posix_message, MINOR_CV_OBSERVATION);
}

void receiveCvColorObservaton(pmq_message *pm){
	pmq_message my_posix_message;
	memcpy((void *)(&my_posix_message),( void * )pm, sizeof(pmq_message));
	cout << " \n \n RecieveCvColorObservation \n \n" << endl;
	plansysObs.NewObservation(my_posix_message, MINOR_CV_COLOR_OBSERVATION);
}

void receivePositionUpdate(pmq_message *pm){
	pmq_message my_posix_message;
	memcpy((void *)(&my_posix_message),( void * )pm, sizeof(pmq_message));
	plansysObs.NewObservation(my_posix_message, MINOR_NAVSYS_POSITION);
}

void receiveWaypointReached(pmq_message *pm) {
	pmq_message my_posix_message;
	ai_waypoint waypointReached;
	memcpy((void *)(&my_posix_message),( void * )pm, sizeof(pmq_message));
	memcpy((void *)(&waypointReached),(void *)pm->data, sizeof(ai_waypoint));
	plansysObs.SetLastWaypointReachedTag(waypointReached.tag);
	if(plansysObs.GetLastWaypointReachedTag() == plansysObs.GetLastWaypointSentCounter()){
		plansysObs.NewObservation(my_posix_message, pm->minor);	
		cout << "Waypoint reached! tag: " << waypointReached.tag << endl;
	}
}

void receiveProxyMessage(pmq_message *pm) {
	pmq_message my_posix_message;
	memcpy((void *)(&my_posix_message),( void * )pm, sizeof(pmq_message));
}

void receiveCmdProxyMessage(pmq_message *pm) {
	if(pm->minor == MINOR_CMD_SYSTEM_GO) {
		receivedGameStartMessage = TRUE;
		cout << " " << endl;
		cout << "Recieve CMD START MESSAGE " << endl;
		cout << " " << endl;
	}
	if(pm->minor == MINOR_CMD_SYSTEM_INITIALIZE) {
		cout << "pm->minor == MINOR_CMD_SYSTEM_INITIALIZE" << endl;
		receivedTeamColor = FALSE;
		receivedGameStartMessage = FALSE;
		cout << "recievedGameStartMessage = FALSE" << endl;
		gameResetMessageTimer = TRUE;
		cout << "gameResetMessageTimer = TRUE" << endl;
		gameResetMessageMain = TRUE;
		cout << "gameResetMessageMain = TRUE" << endl;
		//plansysObs.ClearTheActiveStrategy();
		plansysObs.NewObservation(*pm, pm->minor);
	}
	
}

void receiveCmdTeamColor(pmq_message *pm) {
	if(pm->minor == MINOR_CMD_SET_TEAM_COLOR_BLUE) {
		teamColor = TEAM_COLOR_BLUE;
		cout << " " << endl;
		cout << "recieveCmdTeamColor TEAM_COLOR_BLUE" << endl;
		cout << " " << endl;
		receivedTeamColor = TRUE;
	}
	else if(pm->minor == MINOR_CMD_SET_TEAM_COLOR_RED) {
		teamColor = TEAM_COLOR_RED;
		cout << " " << endl;
		cout << "recieveCmdTeamColor TEAM_COLOR_RED" << endl;
		cout << " " << endl;
		receivedTeamColor = TRUE;
	}
	else{
		// Error handling 
		cout << " " << endl;
		cout << " " << endl;
		cout << "recieveCmdTeamColor ERROR" << endl;
		cout << " " << endl;
		cout << " " << endl;
	}
}
void receiveLowBatteryMessage(pmq_message *pm) {
	#ifdef VOLTAGE_SURVEILLANCE
		lowBattery = TRUE;
		plansysObs.NewObservation(*pm, pm->minor);
	#endif
}

void receiveBallStored(pmq_message *pm) {
	plansysObs.NewObservation(*pm, pm->minor);
}

void receiveWheelReady(pmq_message *pm){
	plansysObs.NewObservation(*pm, pm->minor);
}

void receiveBallsReleased(pmq_message *pm) {
	plansysObs.NewObservation(*pm, pm->minor);
}

void receiveColorDetected(pmq_message *pm) {
	plansysObs.NewObservation(*pm, pm->minor);
}

void receiveSwitchInterrupts(pmq_message *pm){
	plansysObs.NewObservation(*pm, pm->minor);
}

void receiveLocalWaypoint(pmq_message *pm){
	plansysObs.NewObservation(*pm, pm->minor);
}

void sendReleaseBalls( ball_message *new_ball_message, MessageHandler *proxysysMessageHandler ) {
	proxysysMessageHandler->sendMessage( (char *)new_ball_message, (int)sizeof(ball_message), MINOR_RELEASE_BALLS, PRIORITY_HIGH );
}

void sendBallAck( ball_message *new_ball_message, MessageHandler *proxysysMessageHandler ) {
	proxysysMessageHandler->sendMessage( (char *)new_ball_message, (int)sizeof(ball_message), MINOR_COLOR_ACK, PRIORITY_HIGH );
}

void sendSetArms( ball_message *new_ball_message, MessageHandler *proxysysMessageHandler ) {
	proxysysMessageHandler->sendMessage( (char *)new_ball_message, (int)sizeof(ball_message), MINOR_SET_ARMS, PRIORITY_HIGH );
}

void sendPositionArms( int angle, int onOff, int dir, MessageHandler *proxysysMessageHandler ){
	ball_message my_ball_message;
	my_ball_message.data[0] = angle;
	my_ball_message.data[1] = onOff;
	my_ball_message.data[2] = dir;
	//my_ball_message.data[2] = counter;
	counter ++;
	//sendSetArms( &my_ball_message, proxysysMessageHandler );
	proxysysMessageHandler->sendMessage( (char *)&my_ball_message, (int)sizeof(ball_message), MINOR_SET_ARMS, PRIORITY_HIGH );
	cout << "Positioning arms, angle: " << angle << ", onOff: " << onOff << ", dir: " << dir << endl;
}

void sendAdjustPosition( collision_detection_message *adjust_message, MessageHandler *navsysMessageHandler ) { 
	navsysMessageHandler->sendMessage( (char *)adjust_message, (int)sizeof(collision_detection_message), MINOR_NAVSYS_ADJUST_POSITION, PRIORITY_HIGH );
}

int waitForTeamColorMessage( MessageHandler *proxysysMessageHandler, MessageHandler *navsysMessageHandler ) {
	cout << "Wait for teamColor " << endl;
	while( receivedTeamColor == FALSE){ 
		usleep(10000);
		proxysysMessageHandler->handleAllMessagesNow();
	}
	// Set the team color LED
	if( teamColor == TEAM_COLOR_RED ){
		proxysysMessageHandler->sendCommand(MINOR_SET_LED_TEAM_COLOR_RED ,PRIORITY_HIGH);
	}
	else if( teamColor == TEAM_COLOR_BLUE ){
		proxysysMessageHandler->sendCommand(MINOR_SET_LED_TEAM_COLOR_BLUE ,PRIORITY_HIGH);
	}
	else{
		return -1;
	}
	// Send set init position to navsys.
	// This position is determined by the teamColor.
	SendInitPosition( navsysMessageHandler );
	
	return 0;
}

void waitForGameStartMessage(MessageHandler *navsysMessageHandler){
	cout << "Wait for game start message " << endl;
	while( receivedGameStartMessage == FALSE && gameResetMessageMain == FALSE){ 
		usleep(1000);
		navsysMessageHandler->handleAllMessagesNow();
	}
}

void functionStopRobot(speed_limit *max_speed_limit, MessageHandler *navsysMessageHandler){
		max_speed_limit->u_b = 0x00;
		max_speed_limit->r_b = 0x00;
		navsysMessageHandler->sendMessage( (char *)max_speed_limit, (int)sizeof(speed_limit), MINOR_NAVSYS_SET_SPEED_LIMIT, PRIORITY_HIGHEST );
		usleep(10000);
		clearWaypoints(navsysMessageHandler);
		usleep(300000);
}

void setSpeedLimit(speed_limit *max_speed_limit, MessageHandler *navsysMessageHandler){
	max_speed_limit->u_b = MAX_SPEED_MPS;
	max_speed_limit->r_b = 10.0;
	navsysMessageHandler->sendMessage( (char *)max_speed_limit, (int)sizeof(speed_limit), MINOR_NAVSYS_SET_SPEED_LIMIT, PRIORITY_HIGHEST );
}

/*void sendRelativeInterruptWaypoint(MessageHandler *navsysMessageHandler, interrupt_control_struct *ai_interrupt_control_struct,int count){
	navsysMessageHandler->sendMessage( (char *)&ai_interrupt_control_struct->_interrupt_ai_waypoint.at(count), (int)sizeof(ai_waypoint), MINOR_NAVSYS_RELATIVE_INTERRUPT_WAYPOINT, PRIORITY_HIGH );
}*/

void clearWaypoints(MessageHandler *navsysMessageHandler){
	navsysMessageHandler->sendCommand( MINOR_CMD_CLEAR_WAYPOINTS, PRIORITY_HIGHEST);
}

void sendRelativeRobotWaypoint(MessageHandler *navsysMessageHandler, ai_waypoint *active_waypoint){
	plansysObs.IncrementLastWaypointSentCounter();	
	usleep(1000);
	active_waypoint->tag = plansysObs.GetLastWaypointSentCounter();
	navsysMessageHandler->sendMessage( (char *)active_waypoint, (int)sizeof(ai_waypoint), MINOR_NAVSYS_SET_WAYPOINT_ROBOT_RELATIVE, PRIORITY_HIGH );
	cout << "Relative robot waypoint sent, tag: " << active_waypoint->tag << endl;
}

void sendRobotWaypoint(MessageHandler *navsysMessageHandler, ai_waypoint *active_waypoint){
	plansysObs.IncrementLastWaypointSentCounter();
	usleep(1000);	
	active_waypoint->tag = plansysObs.GetLastWaypointSentCounter();
	navsysMessageHandler->sendMessage( (char *)active_waypoint, (int)sizeof(ai_waypoint), MINOR_NAVSYS_SET_WAYPOINT, PRIORITY_HIGH );
	cout << "Robot waypoint sent, tag: " << active_waypoint->tag << endl;
}

void sendReverseWaypoint(MessageHandler *navsysMessageHandler, int x, int y, double psi, int circle_of_acceptance, int relative){
	ai_waypoint activeWaypoint;
	activeWaypoint.id = -1;
	activeWaypoint.x_l = x;
	activeWaypoint.y_l = y;
	activeWaypoint.psi_l = psi;
	activeWaypoint.circle_of_acceptance = circle_of_acceptance;
	usleep(10000);
	if(relative){
		sendRelativeRobotWaypoint( navsysMessageHandler, &activeWaypoint );
	}
	else{
		sendRobotWaypoint( navsysMessageHandler, &activeWaypoint );
	}
	cout << "Reverse waypoint sent, tag: " << activeWaypoint.tag << endl;
}

void sendRelativeWaypoint(MessageHandler *navsysMessageHandler, int x, int y, double psi, int circle_of_acceptance){
	ai_waypoint activeWaypoint;
	activeWaypoint.id = 1;
	activeWaypoint.x_l = x;
	activeWaypoint.y_l = y;
	activeWaypoint.psi_l = psi;
	activeWaypoint.circle_of_acceptance = circle_of_acceptance;
	plansysObs.IncrementLastWaypointSentCounter();
	usleep(1000);
	activeWaypoint.tag = plansysObs.GetLastWaypointSentCounter();
	sendRelativeRobotWaypoint( navsysMessageHandler, &activeWaypoint );
	cout << "Relative waypoint sent, tag: " << activeWaypoint.tag << endl;
}

void declareSubMessageHandlers(MessageHandler *navsysMessageHandler, MessageHandler *proxysysMessageHandler, MessageHandler *cvsysMessageHandler, MessageHandler *cvsysColorMessageHandler){
	navsysMessageHandler->addSubMessageHandler(receivePositionUpdate, MAJOR_STRUCT, MINOR_NAVSYS_POSITION);
	navsysMessageHandler->addSubMessageHandler(receiveWaypointReached, MAJOR_STRUCT, MINOR_NAVSYS_REACHED_WAYPOINT);
	navsysMessageHandler->addSubMessageHandler(receiveLocalWaypoint, MAJOR_STRUCT, MINOR_LOCAL_WAYPOINT);	

	cvsysMessageHandler->addSubMessageHandler(receiveCvObservaton, MAJOR_STRUCT, MINOR_CV_OBSERVATION);
	
	//cvsysColorMessageHandler->addSubMessageHandler(receiveCvColorObservaton, MAJOR_STRUCT, MINOR_CV_COLOR_OBSERVATION);
	
	proxysysMessageHandler->addSubMessageHandler(receiveProxyMessage, MAJOR_STRUCT, MINOR_PROXY_MESSAGE);
	proxysysMessageHandler->addSubMessageHandler(receiveCmdProxyMessage, MAJOR_COMMAND, MINOR_CMD_SYSTEM_GO);
	proxysysMessageHandler->addSubMessageHandler(receiveCmdProxyMessage, MAJOR_COMMAND, MINOR_CMD_SYSTEM_INITIALIZE);
	proxysysMessageHandler->addSubMessageHandler(receiveCmdTeamColor, MAJOR_COMMAND, MINOR_CMD_SET_TEAM_COLOR_RED);
	proxysysMessageHandler->addSubMessageHandler(receiveCmdTeamColor, MAJOR_COMMAND, MINOR_CMD_SET_TEAM_COLOR_BLUE);
	proxysysMessageHandler->addSubMessageHandler(receiveCollisionDetectionStruct, MAJOR_STRUCT, MINOR_COLLISION_DETECTED);
	proxysysMessageHandler->addSubMessageHandler(receiveLowBatteryMessage, MAJOR_COMMAND, MINOR_CMD_LOW_BATTERY);
	proxysysMessageHandler->addSubMessageHandler(receiveBallStored, MAJOR_STRUCT, MINOR_BALL_STORED);
	proxysysMessageHandler->addSubMessageHandler(receiveWheelReady, MAJOR_COMMAND, MINOR_WHEEL_READY);
	proxysysMessageHandler->addSubMessageHandler(receiveBallsReleased, MAJOR_STRUCT, MINOR_BALLS_RELEASED);
	proxysysMessageHandler->addSubMessageHandler(receiveColorDetected, MAJOR_STRUCT, MINOR_COLOR_DETECTED);
	proxysysMessageHandler->addSubMessageHandler(receiveSwitchInterrupts, MAJOR_STRUCT, MINOR_CMD_SWITCHES);
}

void requestPosition(MessageHandler *navsysMessageHandler){
	navsysMessageHandler->sendCommand( MINOR_CMD_REQUEST_POSITION, PRIORITY_HIGH );
	while(!positionReceived){
		// Check the posix queues for new messages
		navsysMessageHandler->handleAllMessagesNow();
	}
	positionReceived = FALSE;

}

void requestRobotToLocal(MessageHandler *navsysMessageHandler, ai_waypoint *opponent){
	cout << "Relative opponent waypoint sent: x:" << opponent->x_l << ", y: " << opponent->y_l << ", psi: " << opponent->psi_l << endl;
	navsysMessageHandler->sendMessage( (char *)opponent, (int)sizeof(ai_waypoint), MINOR_ROBOT_TO_LOCAL, PRIORITY_HIGH );
}

void sendBeaconMeasurementRequest(MessageHandler *proxysysMessageHandler, int id, int startStop){
	beacon_measure new_measure;
	new_measure.type = id;
	new_measure.start = startStop;
	proxysysMessageHandler->sendMessage( (char *)&new_measure, (int)sizeof(beacon_measure), MINOR_BEACON_MEASUREMENT_REQUEST, PRIORITY_HIGH );
}

