#include "interface.h"
#include "simtest.h"

extern MessageHandler *plansysMessageHandler;

void initMessageHandlers()
{
	plansysMessageHandler->addSubMessageHandler( handleCommands , MAJOR_COMMAND, MINOR_ALL );
	plansysMessageHandler->addSubMessageHandler( handleWPLocalCoordinates, MAJOR_STRUCT,MINOR_NAVSYS_SET_WAYPOINT);
	plansysMessageHandler->addSubMessageHandler( handleWPRobotCoordinates, MAJOR_STRUCT,MINOR_NAVSYS_SET_WAYPOINT_ROBOT_RELATIVE);
	plansysMessageHandler->addSubMessageHandler( handleSetSpeed, MAJOR_STRUCT,MINOR_NAVSYS_SET_SPEED);
	plansysMessageHandler->addSubMessageHandler( handleSetPosition, MAJOR_STRUCT,MINOR_NAVSYS_SET_POSITION);
}

void handleCommands(pmq_message *pm) {
	switch(pm->minor) {
		case MINOR_CMD_SYSTEM_STOP:
			printf("UNHANDLED MESSAGE IN handleCommands!!");			
			cout << "UNHANDLED MESSAGE IN handleCommands!!" << endl;
			break;
		case MINOR_CMD_SYSTEM_GO:
			printf("UNHANDLED MESSAGE IN handleCommands!!");
			cout << "UNHANDLED MESSAGE IN handleCommands!!" << endl;
			break;
		case MINOR_CMD_REQUEST_POSITION:
			posix_robot_state_3dof x;
			returnPosition(&x);
			cout << x.x_l << ", " << x.y_l << ", " << x.psi_l << endl;
			plansysMessageHandler->sendMessage((char *)&x, sizeof(posix_robot_state_3dof), MINOR_NAVSYS_POSITION, PRIORITY_HIGH);
			cout<< "Position sent" << endl;
			break;
		case MINOR_CMD_CLEAR_WAYPOINTS:
			stopRobot();
			break;
		default:
			printf("UNHANDLED MESSAGE IN handleCommands!!");
			cout << "UNHANDLED MESSAGE IN handleCommands!!" << endl;
		break;
	}
	
}

void handleWPLocalCoordinates(pmq_message *pm) {
	ai_waypoint *awp = (ai_waypoint *)pm->data;
	std::cout << "Received waypoint: " << awp->x_l << ", " << awp->y_l << ", " << awp->psi_l << std::endl;
	setWaypoint((double)(awp->x_l)/750,(double)(awp->y_l)/750,(double)(awp->psi_l));
}

void handleWPRobotCoordinates(pmq_message *pm) {
	ai_waypoint *awp = (ai_waypoint *)pm->data;
	std::cout << "Received waypoint: " << awp->x_l << ", " << awp->y_l << ", " << awp->psi_l << std::endl;
	setRelativeWaypoint((double)(awp->x_l)/750,(double)(awp->y_l)/750,(double)(awp->psi_l));
}

void handleSetSpeed(pmq_message *pm) {
	/*speed *s = (speed *)pm->data;
	cout << s->u_b << endl;
	robotModel->setSpeed(s->u_b, s->r_b);
	*/
}

void handleSetPosition(pmq_message *pm) {
	//std::cout << "Wtf!" << std::endl;
	//posix_robot_state_3dof *prs3d = (posix_robot_state_3dof *)pm->data;
	//robotModel->setPosition(((double)(prs3d->x_l))/1000, ((double)(prs3d->y_l))/1000, ((double)(prs3d->psi_l)));	 
}
