#include <iostream>
#include <sys/time.h>
#include <libplayerc++/playerc++.h>

#include "interface.h"
#include "simtest.h"

using namespace PlayerCc;

MessageHandler *plansysMessageHandler;

double xPos, yPos, yaw, globalX, globalY, globalYaw, x, y, newYaw;

PlayerClient    robot("localhost");
Position2dProxy pp(&robot,0);

void returnPosition(posix_robot_state_3dof *pos)
{
	pos->x_l = xPos;
	pos->y_l = yPos;
	pos->psi_l = yaw;
}

void setWaypoint(double x, double y, double yaw)
{
	pp.GoTo(x,y,newYaw);
}

int main(int argc, char *argv[])
{	
	plansysMessageHandler = new MessageHandler(NAVSYS_ID, PMQ_NAVSYS, PMQ_PLANSYS, true);
	initMessageHandlers();
	
	pp.ResetOdometry();
	//pp.SetSpeed(2,2,2);
	globalX = 0;
	globalY = 0;
	globalYaw = 0;

	ai_waypoint awp;
	
	while(1)
	{
		// read from the proxies
		robot.Read();
		
		// print out sonars for fun
		/*std::cout << sp << std::endl;
		
		// do simple collision avoidance
		if((sp[0] + sp[1]) < (sp[6] + sp[7]))
		turnrate = dtor(-20); // turn 20 degrees per second
		else
		turnrate = dtor(20);
		
		if(sp[3] < 0.500)
		speed = 0;
		else
		speed = 2;*/
		
		// command the motors
		//x = xPos + 2;
		//y = yPos + 2;
		//newYaw = yaw + 0;
		std::cout << "Enter x-position: " << std::endl;
		std::cin >> x;
		std::cout << "Enter y-position: " << std::endl;
		std::cin >> y;
		std::cout << "Enter yaw-angle: " << std::endl;
		std::cin >> newYaw;
		pp.GoTo(x,y,newYaw);
		//pp.SetOdometry(1,1,0.707);
		xPos = pp.GetXPos();
		yPos = pp.GetYPos();
		yaw = pp.GetYaw();
		std::cout << "************************************" << std::endl;
		std::cout << "X-pos: " << xPos << std::endl;
		std::cout << "Y-pos: " << yPos << std::endl;
		std::cout << "yaw: " << yaw << std::endl;
		std::cout << "************************************" << std::endl;
		while((xPos<(x-0.02)) || (yPos<(y-0.02)) || (yaw>(newYaw+0.1)))
		{
			robot.Read();
			xPos = pp.GetXPos();
			yPos = pp.GetYPos();
			yaw = pp.GetYaw();
			/*std::cout << "------------------------------------" << std::endl;
			std::cout << "X-pos: " << xPos << std::endl;
			std::cout << "Y-pos: " << yPos << std::endl;
			std::cout << "yaw: " << yaw << std::endl;
			std::cout << "------------------------------------" << std::endl;*/
			usleep(50000);
		}
		awp.x_l = (int)xPos*1000;
		awp.y_l = (int)yPos*1000;
		awp.psi_l = yaw;
		plansysMessageHandler->sendMessage((char *)&awp, sizeof(ai_waypoint), MINOR_NAVSYS_REACHED_WAYPOINT, PRIORITY_HIGH);
	}
}
