#ifndef GATEWAY_BALL_SORTING_H
#define GATEWAY_BALL_SORTING_H

#include <pthread.h>
#include <cstdio>
#include <cstdlib>
#include <cerrno>
#include <ctype.h>
#include <unistd.h>   // exit
#include <signal.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>    // O_RDWR

#include <libpcan.h>
#include <pcan.h>

#include <math.h>

#include "main.h"
#include "gatewayConfig.h"
#include "posix_message_config.h"
#include "MessageHandler.h"
#include "posix_message_queue.h"
#include "can_bus.h"
#include "observation_structs.h"
#include "common.h"

void gatewayWheelReady(MessageHandler *plansysMessageHandler);
void gatewayBallStored(__u8 *mdata, MessageHandler *plansysMessageHandler);
void gatewayBallsReleased(__u8 *mdata, MessageHandler *plansysMessageHandler);
void gatewayColorDetected(__u8 *mdata, MessageHandler *plansysMessageHandler);
void gatewaySendSwitchInterrupt(__u8 *mdata, MessageHandler *plansysMessageHandler);

void gatewayReleaseBalls(pmq_message *pm);
void gatewayColorAck(pmq_message *pm);
void gatewaySetArms(pmq_message *pm);

#endif
