#include "gatewayCollisionDetection.h"
#include <sys/time.h>

timeval collision_timer;
timeval start_timer;
double game_started_timer = 0;
double collision_detect_timer_1 = 0;
double collision_detect_timer_2 = 0;

bool game_started = false;

int collision_detection_time = 0;

int setStartTimerCollision(){
  game_started = true;
  gettimeofday(&start_timer, NULL);
  game_started_timer = start_timer.tv_sec;
  collision_detect_timer_1 = game_started_timer;
  collision_detect_timer_2 = game_started_timer;

  return 0;
}

void gatewayRequestDistanceMeasurement(pmq_message *pm) {
	TPCANMsg canSendStruct;
	canSendStruct.ID = CANID_REQUEST_MEASUREMENTS;
	canSendStruct.MSGTYPE = MSGTYPE_STANDARD;
	canSendStruct.LEN = 0x00;

	can_send_message( &canSendStruct );

}


/**
 * MINOR_FLASH_SENSOR_BOARD_LED
 * flashes sensor 2 - 2 0 0 0 0 0 0 0
 * 0 0 0 1 4 1 1 0 // Flashes all one time
 * 0 0 0 1 4 1 5 0 // Flashes all five time
 *
 * 01 FF 00 01 03 01 01 0
 * slår lyset brått på og fader det ut
 */

void gatewayFlashSensorBordLeds(pmq_message *pm) {

	collision_detection_message collision_message;
	memcpy((void *)(&collision_message),( void * )pm->data, sizeof(collision_detection_message));


	TPCANMsg canSendStruct;
	canSendStruct.ID = CANID_FLASH_SENSOR_BOARD_LED;
	canSendStruct.MSGTYPE = MSGTYPE_STANDARD;
	canSendStruct.LEN = 0x08;
	canSendStruct.DATA[0] = 0;//collision_message.data[0];
	canSendStruct.DATA[1] = 0;//collision_message.data[1];
	canSendStruct.DATA[2] = 0;//collision_message.data[2];
	canSendStruct.DATA[3] = 1;//collision_message.data[3];
	canSendStruct.DATA[4] = 4;//collision_message.data[4];
	canSendStruct.DATA[5] = 1;//collision_message.data[5];
	canSendStruct.DATA[6] = 2;//collision_message.data[6];
	canSendStruct.DATA[7] = 0;//collision_message.data[7];

	can_send_message( &canSendStruct );

}

int gatewaySendCollisionDetected(__u8 *mdata, MessageHandler *plansysMessageHandler, MessageHandler *navsysMessageHandler) {
	int i;
	//gettimeofday(&collision_timer, NULL);
	//collision_detect_timer_1 = collision_timer.tv_sec;

	//if(game_started_timer > collision_detect_timer_1 - 10){

	//	if(collision_detect_timer_1 >= collision_detect_timer_2 + 3){

			collision_detection_message collision_message;

			for(i = 0; i < 8; i++){
				collision_message.data[i] = mdata[i];
			}
			plansysMessageHandler->sendMessage((char *)&collision_message, (int)sizeof(collision_detection_message), MINOR_COLLISION_DETECTED, PRIORITY_HIGHEST );

			/*collision_detect_timer_2 = collision_detect_timer_1;
			speed_limit max_speed_limit;
			max_speed_limit.u_b = 0.0;
			max_speed_limit.r_b = 0.0;
			navsysMessageHandler->sendMessage( (char *)&max_speed_limit, (int)sizeof(speed_limit), MINOR_NAVSYS_SET_SPEED_LIMIT, PRIORITY_HIGHEST );
		    */
		    //cout << "collisionDetection navsys" << endl;
		//}
	//}
	//collision_detection_time++;
	return 0;
}

int gatewaySendRangeMessurement(__u8 *mdata, MessageHandler *plansysMessageHandler) {
	int i;
	collision_detection_message collision_message;
	for(i = 0; i < 8; i++){
		collision_message.data[i] = mdata[i];
	}
	plansysMessageHandler->sendMessage((char *)&collision_message, (int)sizeof(collision_detection_message), MINOR_RANGE_MEASUREMENTS, PRIORITY_HIGH );

	return 0;


}



