#ifndef GATEWAY_COLLISION_DETECTION_H
#define GATEWAY_COLLISION_DETECTION_H

//****************************************************************************
// Gunnar Kjemphol
// Eurobot 2007
//
//****************************************************************************

// INCLUDES
#include <pthread.h>
#include <cstdio>
#include <cstdlib>
#include <cerrno>
#include <ctype.h>
#include <unistd.h>   // exit
#include <signal.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>    // O_RDWR

#include <libpcan.h>
#include <pcan.h>

#include <math.h>

#include "main.h"
#include "gatewayConfig.h"
#include "posix_message_config.h"
#include "MessageHandler.h"
#include "posix_message_queue.h"
#include "can_bus.h"
#include "observation_structs.h"
#include "common.h"



void gatewayRequestDistanceMeasurement(pmq_message *pm);

int setStartTimerCollision();

void gatewayFlashSensorBordLeds(pmq_message *pm);

int gatewaySendCollisionDetected(__u8 *mdata, MessageHandler *plansysMessageHandler, MessageHandler *navsysMessageHandler);

int gatewaySendRangeMessurement(__u8 *mdata, MessageHandler *plansysMessageHandler);


#endif
