#ifndef CONTROLLER_H
#define CONTROLLER_H

#define GROUP_NONE 0

#include <string>

using namespace std;

class Controller {
    public:	

        Controller(string name, int id) {
			this->id = id;
			this->name = name;
			group = GROUP_NONE;
		}

		Controller(string name, int id, int group) {
			this->id = id;
			this->group = group;
			this->name = name;
		}

		virtual ~Controller() {
			// Nothing yet.
		}

		// Overloaded << operator using friend for private data access.
		//virtual ostream& operator<<(ostream& output, const Controller& pid) {

		//}

		int getGroup() {
			return group;
		}

		void setGroup(int group) {
			this->group = group;
		}

		virtual double update(const double measurement, const double reference, const double dt) {
			return 0;
		}
		

    protected:

		int id;
		int group;
		string name;
};

#endif

