#include "CoordinateTransform.h"


// Double transformations:

/**
* Transform a coordinate in body coordinates to local coordinates.
*/
void body2Local(CoordBody cb, CoordLocal clRef, AngleEuler aeRef, CoordLocal *cl) {
	double x,y,z;
	//cout << cb << *cl << " r: " << aeRef.getPsi() << " p: " << aeRef.getTheta() << " y: " << aeRef.getPhi() << "\n";

	x = (cos(aeRef.getPsi())*cos(aeRef.getTheta()))*cb.getX() +(-sin(aeRef.getPsi())*cos(aeRef.getPhi())+cos(aeRef.getPsi())*sin(aeRef.getTheta())*sin(aeRef.getPhi()))*cb.getY() + (sin(aeRef.getPsi())*sin(aeRef.getPhi())+cos(aeRef.getPsi())*cos(aeRef.getPhi())*sin(aeRef.getTheta()))*cb.getZ();
	y = (sin(aeRef.getPsi())*cos(aeRef.getTheta()))*cb.getX() + (cos(aeRef.getPsi())*cos(aeRef.getPhi())+sin(aeRef.getPhi())*sin(aeRef.getTheta())*sin(aeRef.getPsi()))*cb.getY() + (-cos(aeRef.getPsi())*sin(aeRef.getPhi())+sin(aeRef.getTheta())*sin(aeRef.getPsi())*cos(aeRef.getPhi()))*cb.getZ();
	z = -sin(aeRef.getTheta())*cb.getX() + cos(aeRef.getTheta())*sin(aeRef.getPhi())*cb.getY() + cos(aeRef.getTheta())*cos(aeRef.getPhi())*cb.getZ();
	//cout << -sin(aeRef.getTheta())*cb.getX() << " , " << cos(aeRef.getTheta())*sin(aeRef.getPhi())*cb.getY() << " , " << cos(aeRef.getTheta())*cos(aeRef.getPhi())*cb.getZ() << "\n";
	//cout << "Z: " << z << "\n";

	cl->setX(x+clRef.getX());
	cl->setY(y+clRef.getY());
	cl->setZ(z+clRef.getZ());
}

void local2Body(CoordLocal cb, CoordLocal clRef, AngleEuler aeRef, CoordBody *cl) {
	double x,y,z;

	x = (cos(-aeRef.getPsi())*cos(-aeRef.getTheta()))*(cb.getX()-clRef.getX()) +(-sin(-aeRef.getPsi())*cos(-aeRef.getPhi())+cos(-aeRef.getPsi())*sin(-aeRef.getTheta())*sin(-aeRef.getPhi()))*(cb.getY()-clRef.getY()) + (sin(-aeRef.getPsi())*sin(-aeRef.getPhi())+cos(-aeRef.getPsi())*cos(-aeRef.getPhi())*sin(-aeRef.getTheta()))*(cb.getZ()-clRef.getZ());
	y = (sin(-aeRef.getPsi())*cos(-aeRef.getTheta()))*(cb.getX()-clRef.getX()) + (cos(-aeRef.getPsi())*cos(-aeRef.getPhi())+sin(-aeRef.getPhi())*sin(-aeRef.getTheta())*sin(-aeRef.getPsi()))*(cb.getY()-clRef.getY()) + (-cos(-aeRef.getPsi())*sin(-aeRef.getPhi())+sin(-aeRef.getTheta())*sin(-aeRef.getPsi())*cos(-aeRef.getPhi()))*(cb.getZ()-clRef.getZ());
	z = -sin(-aeRef.getTheta())*(cb.getX()-clRef.getX()) + cos(-aeRef.getTheta())*sin(-aeRef.getPhi())*(cb.getY()-clRef.getY()) + cos(-aeRef.getTheta())*cos(-aeRef.getPhi())*(cb.getZ()-clRef.getZ());


	cl->setX(x);
	cl->setY(y);
	cl->setZ(z);
}

