/**
* Coordinate transformation factory class.
*
* Kristian M. Knausgård <kmk@wait.no> - 2007
*/

#ifndef COORDINATE_TRANSFORM_H
#define COORDINATE_TRANSFORM_H

#include <math.h>
#include <iostream>
#include "constants.h"
#include "Coordinate.h"


using namespace std;



void body2Local(CoordBody cb, CoordLocal clRef, const AngleEuler aeRef, CoordLocal *cl);
void local2Body(CoordLocal cb, CoordLocal clRef, const AngleEuler aeRef, CoordBody *cl);

class CoordinateTransform {
    public:
        CoordinateTransform();
		~CoordinateTransform();

		
		


/*
		// Transform Local (e.g. Table) Coordinates to North East Down (NED) coordinates.
		static double *local2ned(double *coordLocal);
		// Transform North East Down (NED) coordinates to Local Coordinates.
		static double *ned2local(double const *coordNED);
		// Transform Local (e.g. Table) Coordinates to Body coordinates.
*/		
/*
		static CoordLo *local2body(double const *coordLocal);
		// Transform Body coordinates to Local coordinates (e.g. Table).
		static double *body2local(double const *coordBody);
		// Transform Azimuth Elevation (AzEl) coordinates to Local coordinates.
		static double *azel2local(double const *coordAzEl);
		// Transform Local coordinates to Azimuth Elevation (AzEl) coordinates.
		static double *local2azel(double const *coordLocal);

		// Transform Local (e.g. Table) Coordinates to North East Down (NED) coordinates.
		static int *local2ned(int const *coordLocal);
		// Transform North East Down (NED) coordinates to Local Coordinates.
		static int *ned2local(int const *coordNED);
		// Transform Local (e.g. Table) Coordinates to Body coordinates.
		static int *local2body(int const *coordLocal);
		// Transform Body coordinates to Local coordinates (e.g. Table).
		static int *body2local(int const *coordBody);
		// Transform Azimuth Elevation (AzEl) coordinates to Local coordinates.
		static int *azel2local(int const *coordAzEl);
		// Transform Local coordinates to Azimuth Elevation (AzEl) coordinates.
		static int *local2azel(int const *coordLocal);
*/
/*
		// Transform Local (e.g. Table) Coordinates to North East Down (NED) coordinates.
		static CoordNED local2ned(CoordLocal coordLocal);
		// Transform North East Down (NED) coordinates to Local Coordinates.
		static CoordNED ned2local(CoordNED coordNED);
		// Transform Local (e.g. Table) Coordinates to Body coordinates.
		static double *local2body(CoordLocal coordLocal);
		// Transform Body coordinates to Local coordinates (e.g. Table).
		static double *body2local(double *coordBody);
		// Transform Azimuth Elevation (AzEl) coordinates to Local coordinates.
		static double *azel2local(double[2] coordAzEl);
		// Transform Local coordinates to Azimuth Elevation (AzEl) coordinates.
		static double[2] local2azel(CoordLocal coordLocal);
*/
    private:
};


#endif
