#ifndef NAVSYS_XML_PARSER_H
#define NAVSYS_XML_PARSER_H

using namespace std;

#include <iostream>
#include <vector>
#include <string>
#include <libxml/xmlreader.h>
#include "Feature.h"
#include "PIDController.h"

class NavsysXMLParser
{
public:
	NavsysXMLParser(std::string fileName);
	~NavsysXMLParser();
	int parse(std::string pattern);
	std::vector<Feature> extractFeatures();
	std::vector<Controller *> extractControllers();
private:
	xmlNodePtr getFirst(string str, xmlNodePtr cur);
	bool parsed;
	string fileName;
	xmlDocPtr doc;
    xmlTextReaderPtr reader;
	xmlNodePtr rootNode;
	int getAsInt(string key, xmlNode *rootNode);
};

#endif
