#ifndef EMPTY_ROBOT_TEST_STRATEGY_H
#define EMPTY_ROBOT_TEST_STRATEGY_H

#include <math.h>

#include "Observer.h"
#include "PlansysObservation.h"
#include "planner.h"
#include "waypoint.h"
#include "posix_message_config.h"
#include "init.h"

class EmptyRobotTestStrategy: public Observer {
  public:
	EmptyRobotTestStrategy( PlansysObservation * , int theTeamColor );
	~EmptyRobotTestStrategy();
	void Reset( int theTeamColor );
	void Update( int typeOfObservation );
	void UpdatePriority();
	int GetPriority();
	void AdjustPosition( MessageHandler *navsysMessageHandler );
	void PositionArms( int angle, int dir, int onOff, MessageHandler *proxysysMessageHandler );
	void EmptyRobot(MessageHandler *proxysysMessageHandler);
	void PerformStrategy( MessageHandler *navsysMessageHandler, MessageHandler *proxysysMessageHandler, MessageHandler *cvsysMessageHandler  );
  
  private:
	int lastWaypointSent;	
	int lastWaypointReached;

	collision_detection_message collision_message;	
	
	int ballsReleased;
	int strategyDone;
	int collision;
	int leftSwitch;
	int rightSwitch;
	int minDistance;
	int adjustCount;
	
	int board1, board2, board3, board4, board5;

	double internalState;
	double distance;
	double distance_x;
	double distance_y;
	int timeLeft;
	int priority;
	
	int state;
	enum{
		INIT,
		ADJUST,
		RELEASE_BALLS
		};
	
	PlansysObservation *_subject;
	ai_waypoint ai_waypoint_3d;
	ai_waypoint last_ai_waypoint;
	ai_waypoint activeWaypoint;

	cv_observation my_cv_observation;
	proxy_message my_proxy_message;
	time_message local_time_message;
	control_struct local_control_struct;
};

#endif
