#ifndef TEST_STRATEGY_H
#define TEST_STRATEGY_H

#include <math.h>

#include "Observer.h"
#include "PlansysObservation.h"
#include "planner.h"
#include "waypoint.h"
#include "posix_message_config.h"
#include "init.h"

class TestStrategy: public Observer {
  public:
	TestStrategy( PlansysObservation * , int theTeamColor );
	~TestStrategy();
	void Reset( int theTeamColor );
	void Update( int typeOfObservation );
	int GetPriority();
	void UpdatePriority();
	void pickupBalls(int color);
	void CheckBall( MessageHandler *proxysysMessageHandler );
	void AdjustPosition( MessageHandler *navsysMessageHandler );
	void PositionArms( int angle, int dir, int onOff, MessageHandler *proxysysMessageHandler );
	void PerformStrategy( MessageHandler *navsysMessageHandler, MessageHandler *proxysysMessageHandler, MessageHandler *cvsysMessageHandler  );
  
  private:
	int lastWaypointSent;	
	int lastWaypointReached;
	int newBall;
	int ballStored;
	
	collision_detection_message collision_message;		
	int strategyDone,strategyCompleted;
	int collision;
	int minDistanceDispenser;
	int dispenserStop;
	int adjustCount;

	int board1, board2, board3, board4, board5;
	int ballColor;
	
	int robotState;
	double internalState;
	double distance;
	double distance_x;
	double distance_y;
	int timeLeft;
	int priority;
	
	int state;
	enum{
		INIT,
		PICK_UP_BALL,
		DISPENSER,
	};

	PlansysObservation *_subject;
	ai_waypoint ai_waypoint_3d;
	ai_waypoint last_ai_waypoint;
	ai_waypoint activeWaypoint;
	ai_waypoint redDispenser;
	ai_waypoint blueDispenser;
	
	cv_observation my_cv_observation;
	cv_observation battery_bin_cv_observation;
	proxy_message my_proxy_message;
	time_message local_time_message;
	control_struct local_control_struct;
};

#endif
