#ifndef WHITE_DISPENSER_STRATEGY_H
#define WHITE_DISPENSER_STRATEGY_H

#include <math.h>

#include "Observer.h"
#include "PlansysObservation.h"
#include "planner.h"
#include "waypoint.h"
#include "posix_message_config.h"
#include "init.h"

class WhiteDispenserStrategy: public Observer {
  public:
	WhiteDispenserStrategy( PlansysObservation * , int theTeamColor );
	~WhiteDispenserStrategy();
	void Reset( int theTeamColor );
	void Update( int typeOfObservation );
	int GetPriority();
	void UpdatePriority();
	void pickupBalls(int color);
	void PerformStrategy( MessageHandler *navsysMessageHandler, MessageHandler *proxysysMessageHandler, MessageHandler *cvsysMessageHandler  );
  
  private:
	int lastWaypointSent;	
	int lastWaypointReached;
	
	collision_detection_message collision_message;		
	int strategyDone,strategyCompleted;
	int collision;

	int board1, board2, board3;
	
	double internalState;
	double internalStateRed;
	double internalStateBlue;
	double distance;
	double distance_x;
	double distance_y;
	int timeLeft;
	int priority;
	
	int state;
	enum{
		INIT,
		FIRST_RED_BALL,
		FIRST_BLUE_BALL,
		RED_DISPENSER,
		BLUE_DISPENSER,
		WHITE_DISPENSER_RED,
		WHITE_DISPENSER_BLUE,
		WHITE_BALL_RED,
		WHITE_BALL_BLUE,
	};

	PlansysObservation *_subject;
	ai_waypoint ai_waypoint_3d;
	ai_waypoint last_ai_waypoint;
	ai_waypoint activeWaypoint;
	ai_waypoint redWhiteDispenser;
	ai_waypoint blueWhiteDispenser;
	
	cv_observation my_cv_observation;
	cv_observation battery_bin_cv_observation;
	proxy_message my_proxy_message;
	time_message local_time_message;
	control_struct local_control_struct;
};

#endif
