// #ifdef SEND_RECEIVE_H

#include <iostream>
#include <cstdlib>
#include <sys/time.h>
#include <math.h>

#include "MessageHandler.h"
#include "posix_message_queue.h"
#include "posix_message_config.h"
#include "observations.h"
#include "Observer.h"
#include "PlansysObservation.h"
#include "waypoint.h"

#include "planner.h"

int SendInitPosition( MessageHandler *navsysMessageHandler );
void sendNewPosition( MessageHandler *navsysMessageHandler, ai_waypoint *position_update );
int flashTheSensorBoardLeds( MessageHandler *proxysysMessageHandler );
int askForCvObservation( MessageHandler *cvsysMessageHandler );
void receiveCollisionDetectionStruct(pmq_message *pm);
void receiveCvObservaton(pmq_message *pm);
void receiveCvColorObservaton(pmq_message *pm);
void receivePositionUpdate(pmq_message *pm);
void receiveWaypointReached(pmq_message *pm);
void receiveProxyMessage(pmq_message *pm);
void receiveCmdBatterySort(pmq_message *pm);
void receiveCmdBottleBoxSort(pmq_message *pm);
void receiveCmdProxyMessage(pmq_message *pm);
void receiveCmdTeamColor(pmq_message *pm);
void receiveLowBatteryMessage(pmq_message *pm);
void receiveBallStored(pmq_message *pm);
void receiveWheelReady(pmq_message *pm);
void receiveBallsReleased(pmq_message *pm);
void receiveColorDetected(pmq_message *pm);

void sendReleaseBalls( ball_message *new_ball_message, MessageHandler *proxysysMessageHandler );
void sendBallAck( ball_message *new_ball_message, MessageHandler *proxysysMessageHandler );
void sendSetArms( ball_message *new_ball_message, MessageHandler *proxysysMessageHandler );
void sendPositionArms( int angle, int onOff, int dir, MessageHandler *proxysysMessageHandler );
void sendAdjustPosition( collision_detection_message *adjust_message, MessageHandler *navsysMessageHandler );

int waitForTeamColorMessage( MessageHandler *proxysysMessageHandler, MessageHandler *navsysMessageHandler );
void waitForGameStartMessage(MessageHandler *navsysMessageHandler);
void functionStopRobot(speed_limit *max_speed_limit, MessageHandler *navsysMessageHandler);
void setSpeedLimit(speed_limit *max_speed_limit, MessageHandler *navsysMessageHandler);
//void sendRelativeInterruptWaypoint(MessageHandler *navsysMessageHandler, interrupt_control_struct *ai_interrupt_control_struct,int count);
void clearWaypoints(MessageHandler *navsysMessageHandler);
void sendRelativeRobotWaypoint(MessageHandler *navsysMessageHandler, ai_waypoint *active_waypoint);
void sendRobotWaypoint(MessageHandler *navsysMessageHandler, ai_waypoint *active_waypoint);
void sendReverseWaypoint(MessageHandler *navsysMessageHandler, int x, int y, double psi, int circle_of_acceptance, int relative);
void sendRelativeWaypoint(MessageHandler *navsysMessageHandler, int x, int y, double psi, int circle_of_acceptance);
void declareSubMessageHandlers(MessageHandler *navsysMessageHandler, MessageHandler *proxysysMessageHandler, MessageHandler *cvsysMessageHandler, MessageHandler *cvsysColorMessageHandler);
void requestPosition(MessageHandler *navsysMessageHandler);

void requestRobotToLocal(MessageHandler *navsysMessageHandler, ai_waypoint *opponent);
void sendBeaconMeasurementRequest(MessageHandler *proxysysMessageHandler, int id, int startStop);
// #endif

