// #ifdef SEND_RECEIVE_H

#include <iostream>
#include <cstdlib>
#include <sys/time.h>
#include <math.h>

#include "MessageHandler.h"
#include "posix_message_queue.h"
#include "posix_message_config.h"
#include "observations.h"
#include "Observer.h"
#include "PlansysObservation.h"
#include "waypoint.h"

#include "planner.h"

int SendInitPosition( MessageHandler *navsysMessageHandler );
int flashTheSensorBoardLeds( MessageHandler *proxysysMessageHandler );
int askForCvObservation( MessageHandler *cvsysMessageHandler );
void receiveCollisionDetectionStruct(pmq_message *pm);
void receiveCvObservaton(pmq_message *pm);
void receiveCvColorObservaton(pmq_message *pm);
void receivePositionUpdate(pmq_message *pm);
void receiveWaypointReached(pmq_message *pm);
void receiveProxyMessage(pmq_message *pm);
void receiveCmdBatterySort(pmq_message *pm);
void receiveCmdBottleBoxSort(pmq_message *pm);
void receiveCmdProxyMessage(pmq_message *pm);
void receiveCmdTeamColor(pmq_message *pm);

int waitForTeamColorMessage( MessageHandler *proxysysMessageHandler, MessageHandler *navsysMessageHandler );
void waitForGameStartMessage(MessageHandler *navsysMessageHandler);

// #endif

