#include <math.h>

#include "waypoints.h"

/** Define standard waypoints */

ai_waypoint zeroWaypoint;

ai_waypoint redDispenser;
ai_waypoint blueDispenser;
ai_waypoint redWhiteDispenser;
ai_waypoint blueWhiteDispenser;

ai_waypoint horizontalDispenserLeft;
ai_waypoint horizontalDispenserRight;

ai_waypoint standardContainerRed;
ai_waypoint standardContainerBlue;

ai_waypoint cooledContainerRed;
ai_waypoint cooledContainerBlue;

ai_waypoint firstRedBall;
ai_waypoint firstBlueBall;
ai_waypoint firstWhiteBallRed;
ai_waypoint firstWhiteBallBlue;

ai_waypoint blueWhiteDispenserSupportWaypoint;
ai_waypoint blueDispenserSupportWaypoint;
ai_waypoint redWhiteDispenserSupportWaypoint;
ai_waypoint redDispenserSupportWaypoint;

ai_waypoint waypoints[NUMBER_OF_WAYPOINTS];

void initWaypoints(){

	int circle_of_acceptance = 50;

	zeroWaypoint.id = 1;
	zeroWaypoint.x_l = 0;
	zeroWaypoint.y_l = 0;
	zeroWaypoint.psi_l = 0;
	zeroWaypoint.circle_of_acceptance = circle_of_acceptance;
	waypoints[0] = zeroWaypoint;

//	redDispenser.id = 1;
//	redDispenser.x_l = 700;
//	redDispenser.y_l = 0;
//	redDispenser.psi_l = -M_PI/2;
//	redDispenser.circle_of_acceptance = circle_of_acceptance;
//	waypoints[1] = redDispenser;

	redDispenser.id = 1;
	redDispenser.x_l = 2230;
	redDispenser.y_l = 130;
	redDispenser.psi_l = -90*M_PI/180;
	redDispenser.circle_of_acceptance = circle_of_acceptance;
	waypoints[1] = redDispenser;

//	blueDispenser.id = 1;
//	blueDispenser.x_l = 2300;
//	blueDispenser.y_l = 0;
//	blueDispenser.psi_l = M_PI/2;
//	blueDispenser.circle_of_acceptance = circle_of_acceptance;
//	waypoints[2] = blueDispenser;

	blueDispenser.id = 1;
	blueDispenser.x_l = 730;
	blueDispenser.y_l = 100;
	blueDispenser.psi_l = -90*M_PI/180;
	blueDispenser.circle_of_acceptance = circle_of_acceptance;
	waypoints[2] = blueDispenser;


//	redWhiteDispenser.id = 1;
//	redWhiteDispenser.x_l = 0;
//	redWhiteDispenser.y_l = 750;
//	redWhiteDispenser.psi_l = M_PI;
//	redWhiteDispenser.circle_of_acceptance = circle_of_acceptance;
//	waypoints[3] = redWhiteDispenser;

	redWhiteDispenser.id = 1;
	redWhiteDispenser.x_l = 2910;
	redWhiteDispenser.y_l = 730;
	redWhiteDispenser.psi_l = 0;
	redWhiteDispenser.circle_of_acceptance = circle_of_acceptance;
	waypoints[3] = redWhiteDispenser;

//	blueWhiteDispenser.id = 1;
//	blueWhiteDispenser.x_l = 3000;
//	blueWhiteDispenser.y_l = 750;
//	blueWhiteDispenser.psi_l = 0;
//	blueWhiteDispenser.circle_of_acceptance = circle_of_acceptance;
//	waypoints[4] = blueWhiteDispenser;

	blueWhiteDispenser.id = 1;
	blueWhiteDispenser.x_l = 120;
	blueWhiteDispenser.y_l = 770;
	blueWhiteDispenser.psi_l = 180*M_PI/180;
	blueWhiteDispenser.circle_of_acceptance = circle_of_acceptance;
	waypoints[4] = blueWhiteDispenser;

	horizontalDispenserLeft.id = 1;
	horizontalDispenserLeft.x_l = 1000;
	horizontalDispenserLeft.y_l = 0;
	horizontalDispenserLeft.psi_l = 90*M_PI/180;
	horizontalDispenserLeft.circle_of_acceptance = circle_of_acceptance;
	waypoints[5] = horizontalDispenserLeft;

	horizontalDispenserRight.id = 1;
	horizontalDispenserRight.x_l = 2000;
	horizontalDispenserRight.y_l = 0;
	horizontalDispenserRight.psi_l = 90*M_PI/180;
	horizontalDispenserRight.circle_of_acceptance = circle_of_acceptance;
	waypoints[6] = horizontalDispenserRight;

//	standardContainerRed.id = 1;
//	standardContainerRed.x_l = 2990;
//	standardContainerRed.y_l = 2090;
//	standardContainerRed.psi_l = M_PI/2;
//	standardContainerRed.circle_of_acceptance = circle_of_acceptance;
//	waypoints[7] = standardContainerRed;

	standardContainerRed.id = 1;
	standardContainerRed.x_l = 700;
	standardContainerRed.y_l = 1700;
	standardContainerRed.psi_l = 90*M_PI/180;
	standardContainerRed.circle_of_acceptance = circle_of_acceptance;
	waypoints[7] = standardContainerRed;

//	standardContainerBlue.id = 1;
//	standardContainerBlue.x_l = 10;
//	standardContainerBlue.y_l = 2090;
//	standardContainerBlue.psi_l = M_PI/2;
//	standardContainerBlue.circle_of_acceptance = circle_of_acceptance;
//	waypoints[8] = standardContainerBlue;

	standardContainerBlue.id = 1;
	standardContainerBlue.x_l = 2400;//700;
	standardContainerBlue.y_l = 1700;//2000;
	standardContainerBlue.psi_l = 90*M_PI/180;
	standardContainerBlue.circle_of_acceptance = circle_of_acceptance;
	waypoints[8] = standardContainerBlue;

	cooledContainerRed.id = 1;
	cooledContainerRed.x_l = 2990;
	cooledContainerRed.y_l = 2050;
	cooledContainerRed.psi_l = 180*M_PI/180;
	cooledContainerRed.circle_of_acceptance = circle_of_acceptance;
	waypoints[9] = cooledContainerRed;

	cooledContainerBlue.id = 1;
	cooledContainerBlue.x_l = 10;
	cooledContainerBlue.y_l = 2050;
	cooledContainerBlue.psi_l = 0;
	cooledContainerBlue.circle_of_acceptance = circle_of_acceptance;
	waypoints[10] = cooledContainerBlue;

//	firstRedBall.id = 1;
//	firstRedBall.x_l = 800;
//	firstRedBall.y_l = 400;
//	firstRedBall.psi_l = M_PI/4;
//	firstRedBall.circle_of_acceptance = circle_of_acceptance;
//	waypoints[11] = firstRedBall;

	firstRedBall.id = 1;
	firstRedBall.x_l = 2230;
	firstRedBall.y_l = 400;
	firstRedBall.psi_l = 160*M_PI/180;
	firstRedBall.circle_of_acceptance = circle_of_acceptance;
	waypoints[11] = firstRedBall;

//	firstBlueBall.id = 1;
//	firstBlueBall.x_l = 2200;
//	firstBlueBall.y_l = 400;
//	firstBlueBall.psi_l = M_PI*3/4;
//	firstBlueBall.circle_of_acceptance = circle_of_acceptance;
//	waypoints[12] = firstBlueBall;

	firstBlueBall.id = 1;
	firstBlueBall.x_l = 770;
	firstBlueBall.y_l = 390;
	firstBlueBall.psi_l = 20*M_PI/180;
	firstBlueBall.circle_of_acceptance = circle_of_acceptance;
	waypoints[12] = firstBlueBall;

//	firstWhiteBallRed.id = 1;
//	firstWhiteBallRed.x_l = 520;
//	firstWhiteBallRed.y_l = 800;
//	firstWhiteBallRed.psi_l = M_PI*3/4;
//	firstWhiteBallRed.circle_of_acceptance = circle_of_acceptance;
//	waypoints[13] = firstWhiteBallRed;

	firstWhiteBallRed.id = 1;
	firstWhiteBallRed.x_l = 2450;
	firstWhiteBallRed.y_l = 770;
	firstWhiteBallRed.psi_l = 59*M_PI/180;
	firstWhiteBallRed.circle_of_acceptance = circle_of_acceptance;
	waypoints[13] = firstWhiteBallRed;

//	firstWhiteBallBlue.id = 1;
//	firstWhiteBallBlue.x_l = 2480;
//	firstWhiteBallBlue.y_l = 800;
//	firstWhiteBallBlue.psi_l = M_PI/2;
//	firstWhiteBallBlue.circle_of_acceptance = circle_of_acceptance;
//	waypoints[14] = firstWhiteBallBlue;

	firstWhiteBallBlue.id = 1;
	firstWhiteBallBlue.x_l = 560;
	firstWhiteBallBlue.y_l = 770;
	firstWhiteBallBlue.psi_l = 121*M_PI/180;
	firstWhiteBallBlue.circle_of_acceptance = circle_of_acceptance;
	waypoints[14] = firstWhiteBallBlue;

	blueWhiteDispenserSupportWaypoint.id = 1;
	blueWhiteDispenserSupportWaypoint.x_l = 700;
	blueWhiteDispenserSupportWaypoint.y_l = 750;
	blueWhiteDispenserSupportWaypoint.psi_l = 180*M_PI/180;
	blueWhiteDispenserSupportWaypoint.circle_of_acceptance = circle_of_acceptance;
	waypoints[15] = blueWhiteDispenserSupportWaypoint;

	blueDispenserSupportWaypoint.id = 1;
	blueDispenserSupportWaypoint.x_l = 700;
	blueDispenserSupportWaypoint.y_l = 750;
	blueDispenserSupportWaypoint.psi_l = -90*M_PI/180;
	blueDispenserSupportWaypoint.circle_of_acceptance = circle_of_acceptance;
	waypoints[16] = blueDispenserSupportWaypoint;

	redWhiteDispenserSupportWaypoint.id = 1;
	redWhiteDispenserSupportWaypoint.x_l = 2300;
	redWhiteDispenserSupportWaypoint.y_l = 750;
	redWhiteDispenserSupportWaypoint.psi_l = 0;
	redWhiteDispenserSupportWaypoint.circle_of_acceptance = circle_of_acceptance;
	waypoints[17] = redWhiteDispenserSupportWaypoint;

	redDispenserSupportWaypoint.id = 1;
	redDispenserSupportWaypoint.x_l = 2300;
	redDispenserSupportWaypoint.y_l = 750;
	redDispenserSupportWaypoint.psi_l = -90*M_PI/180;
	redDispenserSupportWaypoint.circle_of_acceptance = circle_of_acceptance;
	waypoints[18] = redDispenserSupportWaypoint;

}

ai_waypoint GetWaypoint(int waypoint){
	return waypoints[waypoint];
}

