close;
clc;

beacon_placement = 0; %cm outside the table border

%Table coordinate system
table_x = 300; %86;
table_y = 210; %48;

%Beacon coordinate system
length_x = table_x + 2*beacon_placement;
length_y = table_y + 2*beacon_placement;

%Original position and heading
x_or = 185.5 + beacon_placement;
y_or = 97 + beacon_placement;
theta_or = 90;

color = input('Choose color, red: r, blue: b: ','s');
switch color
    case 'r'
        beacon1_x = length_x;
        beacon1_y = length_y;
        beacon2_x = 0;
        beacon2_y = length_y/2;
        beacon3_x = length_x;
        beacon3_y = 0;
    case 'b'
        beacon1_x = 0;
        beacon1_y = 0;
        beacon2_x = length_x;
        beacon2_y = length_y/2;
        beacon3_x = 0;
        beacon3_y = length_y;
    otherwise
        disp('Wrong color!')
end

% All utregning gjres med rde beacons, og s speilvendes det etterp
beacon1_xr = length_x;
beacon1_yr = length_y;
beacon2_xr = 0;
beacon2_yr = length_y/2;
beacon3_xr = length_x;
beacon3_yr = 0;

% lambda1 = -input('Enter angle tower 1: ');
% lambda2 = -input('Enter angle tower 2: ');
% lambda3 = -input('Enter angle tower 3: ');

 lambda1 =-(15);
 lambda2 = -(250);
 lambda3 = -(80);
 
L12 = sqrt((beacon1_xr-beacon2_xr)^2+(beacon1_yr-beacon2_yr)^2); %length between tower 1 and 2
L31 = sqrt((beacon1_xr-beacon3_xr)^2+(beacon1_yr-beacon3_yr)^2);
L32 = sqrt((beacon2_xr-beacon3_xr)^2+(beacon2_yr-beacon3_yr)^2);


beta = acosd((L31^2+L12^2-L32^2)/(2*L31*L12)); %Cosine sentence
alpha = atan2(-beacon1_xr+beacon3_xr,L31)*180/pi;

x1 = beacon1_xr;
y1 = beacon1_yr;

phi = (90-beta-alpha);


lambda12 = lambda2-lambda1;
if lambda1>lambda2
    lambda12 = 360+(lambda2-lambda1);
end
lambda31 = lambda1-lambda3;
if lambda3>lambda1
    lambda31 = 360+(lambda1-lambda3);
end


sigma = 180-beta;
gamma = sigma-lambda31;
num = sind(lambda12)*(L12*sind(lambda31)-L31*sind(gamma));
den = L31*sind(lambda12)*cosd(gamma)-L12*cosd(lambda12)*sind(lambda31);
tau = atan2(num,den)*180/pi;

if lambda12<180 && tau<0
    tau = tau+180;
end
if lambda12>180 && tau>0
    tau = tau-180;
end
if abs(sind(lambda12))>abs(sind(lambda31))
    L1 = (L12*sind(tau+lambda12))/(sind(lambda12)); 
else
    L1 = (L31*sind(tau+sigma-lambda31))/(sind(lambda31));
end


theta_R = phi + tau - lambda1;


if color == 'b'
    theta_R = theta_R +180;
end


if theta_R <= -180
    theta_R = theta_R + 360;
end
if theta_R > 180
    theta_R = theta_R - 360;
end

% if color == 'b'
%     if theta_R >0
%         theta_R = theta_R + 2*(90-theta_R);
%     else
%         theta_R = theta_R - 2*(90-abs(theta_R));
%     end
% end


% disp('Robot coordinates (in metres) and heading (in degrees):');
x_R = x1 - L1*cosd(phi+tau) - beacon_placement;
y_R = y1 - L1*sind(phi+tau) - beacon_placement;

if color == 'b'
    x_R = length_x-x_R;
    y_R = length_y-y_R;
end

%   x_R = 160;
%   y_R = 70;
%   theta_R = 60;

vinkel1 = -(atan2(beacon1_y-y_R,beacon1_x-x_R)*180/pi-theta_R);
vinkel1 = vinkel1+360*(vinkel1<0)
vinkel2 = -(atan2(beacon2_y-y_R,beacon2_x-x_R)*180/pi-theta_R);
vinkel2 = vinkel2+360*(vinkel2<0)
vinkel3 = -(atan2(beacon3_y-y_R,beacon3_x-x_R)*180/pi-theta_R);
vinkel3 = vinkel3+360*(vinkel3<0)



% Plotting table border and start rectangles
fill([0+beacon_placement,table_x+beacon_placement,table_x+beacon_placement,0+beacon_placement],[0+beacon_placement,0+beacon_placement,table_y+beacon_placement,table_y+beacon_placement],'y');
hold on
fill([0+beacon_placement,table_x/6+beacon_placement,table_x/6+beacon_placement,0+beacon_placement],[0+beacon_placement,0+beacon_placement,table_x/6+beacon_placement,table_x/6+beacon_placement],'r');
hold on
fill([table_x-table_x/6+beacon_placement,table_x+beacon_placement,table_x+beacon_placement,table_x-table_x/6+beacon_placement],[0+beacon_placement,0+beacon_placement,table_x/6+beacon_placement,table_x/6+beacon_placement],'b');
hold on
plot([table_x/2+beacon_placement 0+beacon_placement 0+beacon_placement table_x/2+beacon_placement],[0+beacon_placement 0+beacon_placement table_y+beacon_placement table_y+beacon_placement],'b-','LineWidth',2);
hold on
plot([table_x/2+beacon_placement table_x+beacon_placement table_x+beacon_placement table_x/2+beacon_placement],[0+beacon_placement 0+beacon_placement table_y+beacon_placement table_y+beacon_placement],'r-','LineWidth',2);
hold on

% Plotting positions of the beacons
plot(beacon1_x,beacon1_y,'ms','MarkerFaceColor',color,'Color','black','MarkerSize',12);
hold on;
text(beacon1_x-table_x/15,beacon1_y+table_y/20,'Beacon 1','FontSize',7);
hold on
plot(beacon2_x,beacon2_y,'ms','MarkerFaceColor',color,'Color','black','MarkerSize',12);
hold on
text(beacon2_x-table_x/15,beacon2_y+table_y/20,'Beacon 2','FontSize',7);
hold on
plot(beacon3_x,beacon3_y,'ms','MarkerFaceColor',color,'Color','black','MarkerSize',12);
hold on
text(beacon3_x-table_x/15,beacon3_y-table_y/20,'Beacon 3','FontSize',7)
hold on

%Plotting the triangle made by the beacons
% line([beacon3_x beacon2_x],[beacon3_y beacon2_y],'Color','black');
% hold on
% line([beacon2_x beacon1_x],[beacon2_y beacon1_y],'Color','black');
% hold on
% line([beacon3_x beacon1_x],[beacon3_y beacon1_y],'Color','black');
% hold on

%Plotting resulting position
plot(x_R+beacon_placement:x_R+(table_x/6)+beacon_placement,y_R+beacon_placement:y_R+beacon_placement);
hold on
plot(x_R+beacon_placement,y_R+beacon_placement,strcat(color,'x'),'MarkerSize',12);
hold on

%Plotting resulting angles between the robot and the beacons
vectarrow([x_R+beacon_placement y_R+beacon_placement],[beacon2_x beacon2_y],color);
hold on
vectarrow([x_R+beacon_placement y_R+beacon_placement],[beacon1_x beacon1_y],color);
hold on
vectarrow([x_R+beacon_placement y_R+beacon_placement],[beacon3_x beacon3_y],color);
hold on
text(x_R+beacon_placement-table_x/15,y_R+beacon_placement+table_y/40,strcat('(x = ',num2str(x_R),',y = ',num2str(y_R),')'),'FontSize',7);
hold on

%Plotting the heading
vectarrow([x_R+beacon_placement y_R+beacon_placement],[x_R+(table_x/6)*cosd(theta_R)+beacon_placement y_R+(table_x/6)*sind(theta_R)+beacon_placement],'green');
hold on
text(x_R+(table_x/6)*cosd(theta_R)+beacon_placement-table_x/35,y_R+(table_x/6)*sind(theta_R)+beacon_placement,num2str(theta_R),'FontSize',7);
hold on

%Plotting dispensers
plot(0+beacon_placement+table_x*70/300,0+beacon_placement+1,'ms','MarkerFaceColor','r','Color','black','MarkerSize',10);
plot(0+beacon_placement+table_x*230/300,0+beacon_placement+1,'ms','MarkerFaceColor','b','Color','black','MarkerSize',10);
plot(0+beacon_placement+1,0+beacon_placement+table_y*75/210,'ms','MarkerFaceColor','w','Color','black','MarkerSize',10);
plot(0+beacon_placement+table_x-1,0+beacon_placement+table_y*75/210,'ms','MarkerFaceColor','w','Color','black','MarkerSize',10);

%Plotting known balls
plot(0+beacon_placement+table_x*80/300,0+beacon_placement+table_y*40/210,'mo','MarkerFaceColor','r','Color','black','MarkerSize',8);
plot(0+beacon_placement+table_x*220/300,0+beacon_placement+table_y*40/210,'mo','MarkerFaceColor','b','Color','black','MarkerSize',8);
plot(0+beacon_placement+table_x*52/300,0+beacon_placement+table_y*80/210,'mo','MarkerFaceColor','w','Color','black','MarkerSize',8);
plot(0+beacon_placement+table_x*248/300,0+beacon_placement+table_y*80/210,'mo','MarkerFaceColor','w','Color','black','MarkerSize',8);

% %Plotting the original position and angles
% plot(x_or,y_or,'x','MarkerSize',12);
% hold on
% vectarrow([x_or y_or],[beacon2_x beacon2_y],'black');
% hold on
% vectarrow([x_or y_or],[beacon1_x beacon1_y],'black');
% hold on
% vectarrow([x_or y_or],[beacon3_x beacon3_y],'black');

axis([-10 length_x+10 -10 length_y+10]);